/*
 *  @(#)SceneGraphChecker.java 1.4 00/12/19 15:41:45
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.j3dfly;

import javax.media.j3d.Node;
import javax.media.j3d.Appearance;
import javax.media.j3d.Material;
import javax.media.j3d.Shape3D;
import com.sun.j3d.demos.utils.scenegraph.traverser.NodeChangeProcessor;
import com.sun.j3d.demos.utils.scenegraph.traverser.TreeScan;

/**
 * @author Paul Byrne
 * @version	1.4, 12/19/00
 */
public class SceneGraphChecker extends Object {
  
  private boolean hasLights;
  private boolean needsLights;

  /** Creates new SceneGraphChecker */
  public SceneGraphChecker() {
  }
  
  /** 
    * Checks if the graph contains any geometry that requires lighting and if
    * the graph contains any Light nodes
    *
    * If there is geometry expecting lights and there are no lights then return
    * true, else return false;
    */
  public synchronized boolean needsLights( javax.media.j3d.BranchGroup bg ) {   
    NodeChangeProcessor gotLight = new NodeChangeProcessor() {
      public void changeNode( Node node ) {
        if (node instanceof javax.media.j3d.Light)
          hasLights = true;
        
        if (node instanceof javax.media.j3d.Shape3D) {
          Appearance app = ((Shape3D)node).getAppearance();
          if (app!=null) {
            Material mat = app.getMaterial();
            if (mat!=null && mat.getLightingEnable()) {
              needsLights = true;
            }
          }
        }
      }
    };
    
    hasLights = false;
    needsLights = false;
    
    TreeScan.findNode( bg, new Class[] { javax.media.j3d.Light.class,
                                         javax.media.j3d.Shape3D.class }, 
                       gotLight, false, true );
    
    return !hasLights & needsLights;
  }
  
  public boolean getHasLights() {
      return hasLights;
  }

}

