/*
 *  @(#)StripifyWorker.java 1.2 00/12/19 15:41:48
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.j3dfly;

import java.awt.Frame;
import javax.swing.SwingUtilities;
import javax.media.j3d.BranchGroup;
import com.sun.j3d.demos.utils.developmenttools.DevelopmentSimpleUniverse;
import com.sun.j3d.demos.utils.gui.StatsDialog;
import com.sun.j3d.demos.utils.scenegraph.traverser.GeometryArrayStripifier;

/**
 * Thread which manages stripification of TriangleArrays in scene
 *
 * @author  Paul Byrne
 * @version 1.2 12/19/00
 */

class StripifyWorker extends Thread {
    
    private DevelopmentSimpleUniverse universe;
    private BranchGroup[] roots;
    private StatsDialog statsDialog;
    private StripifyWaitDialog waitDialog;
    private Runnable showWaitDialog;
    private Runnable hideWaitDialog;
    
    public StripifyWorker( Frame parent,
                           DevelopmentSimpleUniverse universe,
                           BranchGroup[] roots,
                           StatsDialog statsDialog ) {
        this.universe = universe;
        this.roots = roots;
        this.statsDialog = statsDialog;
        
        waitDialog = new StripifyWaitDialog( parent, true );
        
        showWaitDialog = new Runnable() {
            public void run() {
                waitDialog.show();
            }
        };
        
        hideWaitDialog = new Runnable() {
            public void run() {
                waitDialog.hide();
            }
        };
    }
    
    public void run() {
        SwingUtilities.invokeLater( showWaitDialog );
        universe.setLive( false );
        
        GeometryArrayStripifier.stripify( roots );
        
        if (statsDialog!=null)
            statsDialog.calcGeometryStats( roots );
        
        universe.setLive( true );
        SwingUtilities.invokeLater( hideWaitDialog );
    }
}
