/*
 *  @(#)CreateWarpDialog.java 1.3 00/12/19 15:43:10
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.j3dfly.warp;

import javax.swing.JDialog;

/**
 * Dialog box for creating new warp objects
 *
 * @author Paul Byrne
 * @version	1.3, 12/19/00
 */
public class CreateWarpDialog extends javax.swing.JDialog {

    private WarpSet warpSet;
    private boolean isValid;       // Do we have a valid warp name
    private JDialog parent;
    
    /** Creates new form CreateWarpDialog */
    public CreateWarpDialog( JDialog parent,boolean modal, WarpSet warpSet) {
        super (parent, modal);
        this.parent = parent;
        this.warpSet = warpSet;
        isValid = false;
        initComponents ();
        pack ();
        centerOnParent();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        duplicateLabel = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        nameTF = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        descriptionTF = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        okB = new javax.swing.JButton();
        cancelB = new javax.swing.JButton();
        setModal(true);
        setTitle("Create Warp");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        duplicateLabel.setFont(new java.awt.Font ("Dialog", 1, 11));
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          jPanel1.add(duplicateLabel, gridBagConstraints1);
          
          
        jLabel2.setText("Name");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 0;
          gridBagConstraints1.gridy = 1;
          gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 4);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
          jPanel1.add(jLabel2, gridBagConstraints1);
          
          
        jLabel3.setText("Description");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 0;
          gridBagConstraints1.gridy = 2;
          gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 4);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
          jPanel1.add(jLabel3, gridBagConstraints1);
          
          
        nameTF.setPreferredSize(new java.awt.Dimension(100, 21));
          nameTF.setToolTipText("Name for the warp");
          nameTF.setMinimumSize(new java.awt.Dimension(100, 21));
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 1;
          gridBagConstraints1.gridy = 1;
          jPanel1.add(nameTF, gridBagConstraints1);
          
          
        jScrollPane1.setMinimumSize(new java.awt.Dimension(22, 39));
          
          descriptionTF.setToolTipText("Optional description of the warp");
            jScrollPane1.setViewportView(descriptionTF);
            
            gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 1;
          gridBagConstraints1.gridy = 2;
          gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
          jPanel1.add(jScrollPane1, gridBagConstraints1);
          
          
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
        
        
        
        okB.setText("OK");
          okB.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  okBActionPerformed(evt);
              }
          }
          );
          jPanel2.add(okB);
          
          
        cancelB.setText("Cancel");
          cancelB.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  cancelBActionPerformed(evt);
              }
          }
          );
          jPanel2.add(cancelB);
          
          
        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);
        
    }//GEN-END:initComponents

  private void cancelBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBActionPerformed
// Add your handling code here:
      isValid = false;
      setVisible( false );
  }//GEN-LAST:event_cancelBActionPerformed

  private void okBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okBActionPerformed
// Add your handling code here:
      if (warpSet.nameExists( nameTF.getText() )) {
          duplicateLabel.setText("Warp Name is not unique");
          pack();
      } else {
          isValid = true;
          setVisible( false );
      }
  }//GEN-LAST:event_okBActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    /**
     * Return true if the user has entered a valid warp name and
     * pressed OK
     */
    public boolean isValid() {
        return isValid;
    }
    
    public String getName() {
        return nameTF.getText();
    }
    
    public String getDescription() {
        return descriptionTF.getText();
    }
    
    private void centerOnParent() {
        int parentW = parent.getWidth();
        int parentH = parent.getHeight();
        
        setLocation( parentW/2 - getWidth()/2, parentH/2 - getHeight()/2 );
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel duplicateLabel;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JTextField nameTF;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField descriptionTF;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton okB;
    private javax.swing.JButton cancelB;
    // End of variables declaration//GEN-END:variables

}
