/*
 *  @(#)WarpEditorDialog.java 1.4 00/12/19 15:43:12
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.j3dfly.warp;

import javax.swing.DefaultListModel;
import javax.swing.event.ListSelectionListener;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.Transform3D;

/**
 * Dialog box for editing Warps
 *
 * @author Paul Byrne
 * @version	1.4, 12/19/00
  */
public class WarpEditorDialog extends javax.swing.JDialog implements ListSelectionListener {

    private WarpSet warpSet;
    private TransformGroup viewTG;
    private DefaultListModel listModel;
    
    /** Creates new form WarpEditorDialog */
    public WarpEditorDialog(java.awt.Frame parent, 
                            boolean modal,
                            WarpSet warpSet,
                            TransformGroup viewTG ) {
        super (parent, modal);
        this.warpSet = warpSet;
        this.viewTG = viewTG;
        listModel = new DefaultListModel();
        String[] warpName = warpSet.getNames();
        for(int i=0; i<warpName.length; i++)
            listModel.addElement( warpName[i] );
        initComponents ();
        pack ();
        
        warpList.addListSelectionListener( this );
        
        int x = parent.getWidth()/2 - this.getWidth()/2;
        int y = parent.getHeight()/2 - this.getHeight()/2;
        
        setLocation( x, y );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        createWarpB = new javax.swing.JButton();
        deleteWarpB = new javax.swing.JButton();
        makeDefaultB = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        warpList = new javax.swing.JList();
        jPanel2 = new javax.swing.JPanel();
        okB = new javax.swing.JButton();
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        createWarpB.setToolTipText("Create a Warp for the current View");
          createWarpB.setLabel("Create Warp");
          createWarpB.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  createWarpBActionPerformed(evt);
              }
          }
          );
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 0;
          gridBagConstraints1.gridy = 1;
          jPanel1.add(createWarpB, gridBagConstraints1);
          
          
        deleteWarpB.setToolTipText("Delete the selected Warp");
          deleteWarpB.setText("Delete");
          deleteWarpB.setEnabled(false);
          deleteWarpB.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  deleteWarpBActionPerformed(evt);
              }
          }
          );
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 1;
          gridBagConstraints1.gridy = 1;
          jPanel1.add(deleteWarpB, gridBagConstraints1);
          
          
        makeDefaultB.setToolTipText("Make the selected warp the default (initial) warp for this file");
          makeDefaultB.setText("Make Default");
          makeDefaultB.setEnabled(false);
          makeDefaultB.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  makeDefaultBActionPerformed(evt);
              }
          }
          );
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 2;
          gridBagConstraints1.gridy = 1;
          jPanel1.add(makeDefaultB, gridBagConstraints1);
          
          
        jScrollPane1.setMinimumSize(new java.awt.Dimension(250, 100));
          
          warpList.setPreferredSize(new java.awt.Dimension(250, 100));
            warpList.setModel(listModel);
            warpList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
            jScrollPane1.setViewportView(warpList);
            
            gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridwidth = 3;
          jPanel1.add(jScrollPane1, gridBagConstraints1);
          
          
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
        
        
        
        okB.setText("OK");
          okB.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  okBActionPerformed(evt);
              }
          }
          );
          jPanel2.add(okB);
          
          
        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);
        
    }//GEN-END:initComponents

  private void okBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okBActionPerformed
// Add your handling code here:
      setVisible( false );
  }//GEN-LAST:event_okBActionPerformed

  private void makeDefaultBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_makeDefaultBActionPerformed
// Add your handling code here:
      warpSet.setDefaultWarp( (String)warpList.getSelectedValue() );
  }//GEN-LAST:event_makeDefaultBActionPerformed

  private void deleteWarpBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteWarpBActionPerformed
// Add your handling code here:
      warpSet.deleteWarpPosition( (String)warpList.getSelectedValue() );
      listModel.removeElement( warpList.getSelectedValue() );
  }//GEN-LAST:event_deleteWarpBActionPerformed

  private void createWarpBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createWarpBActionPerformed
// Add your handling code here:
      Transform3D trans = new Transform3D();
      viewTG.getTransform( trans );
      
      String name =warpSet.createWarp( trans,
                          this );
      
      listModel.addElement( name );

  }//GEN-LAST:event_createWarpBActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        viewTG = null;
        dispose ();
    }//GEN-LAST:event_closeDialog

    /**
     * List Selection Listener
     */
    public void valueChanged(final javax.swing.event.ListSelectionEvent p1) {
        makeDefaultB.setEnabled( true );
        deleteWarpB.setEnabled( true );
    }    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton createWarpB;
    private javax.swing.JButton deleteWarpB;
    private javax.swing.JButton makeDefaultB;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList warpList;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton okB;
    // End of variables declaration//GEN-END:variables

}
