/*
 *  @(#)WarpPosition.java 1.3 00/12/19 15:43:13
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.j3dfly.warp;

import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.io.Serializable;
import javax.media.j3d.Transform3D;
import javax.vecmath.Matrix4d;

/**
 * Encapsulates the name and position/orientation of a warp
 *
 * @author Paul Byrne
 * @version	1.3, 12/19/00
 */
class WarpPosition extends java.lang.Object implements Serializable {

    private String name;
    private String description;
    private Transform3D position;
    
    /** Creates new WarpObject */
    public WarpPosition() {
        name = null;
        position = null;
        description = null;
    }
    
    public WarpPosition( String name, String description, Transform3D position ) {
        this.name = name;
        this.description = description;
        this.position = position;
    }
    
    public String getName() {
        return name;
    }
    
    public void setName( String name ) {
        this.name = name;
    }
    
    public String getDescription() {
        return description;
    }
    
    public void setDescription( String description ) {
        this.description = description;
    }

    public Transform3D getPosition() {
        return position;
    }
    
    public void setPosition( Transform3D position ) {
        this.position = position;
    }

    /**
     * Write the contents of this object to the stream
     */
    private void writeObject( ObjectOutputStream out ) throws IOException {
        out.writeUTF( name );
        out.writeUTF( description );
        Matrix4d mat = new Matrix4d();
        position.get(mat);
        out.writeObject( mat );
    }
    
    /**
     * Read this object with data from the stream
     */
    private void readObject( ObjectInputStream in ) throws IOException, ClassNotFoundException {
        name = in.readUTF();
        description = in.readUTF();
        Matrix4d mat = (Matrix4d)in.readObject();
        position = new Transform3D( mat );
    }
}
