/*
 *  @(#)SceneGraphChangeListener.java 1.2 00/12/19 15:48:26
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */

package com.sun.j3d.demos.utils.developmenttools;

import javax.media.j3d.BranchGroup;

/** 
 *
 * @author  paulby
 * @version 
 */
public interface SceneGraphChangeListener {

  /**
    * A new Branch graph is about to be added to the Locale
    */
  public void graphAdded( BranchGroup newGraph );
  
  /**
    * A Branch graph has been removed, the remove has taken place
    * when this method is called
    */
  public void graphRemoved( BranchGroup graph );
  
  /**
    * A branch graph is about to be replaced in the Locale
    */
  public void graphReplaced( BranchGroup oldGraph, BranchGroup newGraph );
  
  /**
    * Called when the Locale is notified of SceneGraph Structure changes
    * by a call to notifyGraphChanged
    *
    */
  public void graphChanged( BranchGroup graph, javax.media.j3d.Node node );
}
