/*
 *  @(#)BoundsPanel.java 1.2 00/12/19 16:49:15
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.gui;

import javax.media.j3d.Bounds;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.BoundingBox;
import javax.media.j3d.BoundingPolytope;
import javax.vecmath.Point3d;

/**
 * @author Paul Byrne
 * @version	1.2, 12/19/00
 */
public class BoundsPanel extends javax.swing.JPanel implements Tuple3dChangeListener {

  private java.awt.CardLayout cardLayout;
  private Bounds currentBounds;
  private BoundsChangeListener changeListener=null;
  
  /** Creates new form BoundsPanel */
  public BoundsPanel() {
    initComponents ();
    cardLayout = (java.awt.CardLayout)cardPanel.getLayout();
    upperCornerPanel.setChangeListener( this );
    lowerCornerPanel.setChangeListener( this );
    centerPanel.setChangeListener( this );
  }
  
  public void setBounds( javax.media.j3d.Bounds bounds ) {
    currentBounds = bounds;
    setControls();
  }
  
  public void setBoundsChangeListener( BoundsChangeListener listener ) {
    changeListener = listener;
  }
  
  public void setReadOnly( boolean readOnly ) {
    centerPanel.setReadOnly( readOnly );
    radiusTF.setEditable( !readOnly );
    boundsTypeC.setEnabled( !readOnly );
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
      cardPanel = new javax.swing.JPanel();
      boxPanel = new javax.swing.JPanel();
      jPanel3 = new javax.swing.JPanel();
      lowerCornerPanel = new com.sun.j3d.demos.utils.gui.Tuple3dPanel();
      jPanel4 = new javax.swing.JPanel();
      upperCornerPanel = new com.sun.j3d.demos.utils.gui.Tuple3dPanel();
      spherePanel = new javax.swing.JPanel();
      radiusL = new javax.swing.JLabel();
      radiusTF = new javax.swing.JTextField();
      centerL = new javax.swing.JLabel();
      jPanel1 = new javax.swing.JPanel();
      centerPanel = new com.sun.j3d.demos.utils.gui.Tuple3dPanel();
      polytopePanel = new javax.swing.JPanel();
      jLabel1 = new javax.swing.JLabel();
      nullPanel = new javax.swing.JPanel();
      jLabel6 = new javax.swing.JLabel();
      jPanel2 = new javax.swing.JPanel();
      boundsTypeC = new javax.swing.JComboBox( new String[] {
          "Bounding Sphere",
          "Bounding Box",
          "Bounding Polytope",
          "Null Bounds" });
          showBoundsCB = new javax.swing.JCheckBox();
          setLayout(new java.awt.BorderLayout());
          
          cardPanel.setLayout(new java.awt.CardLayout());
          cardPanel.setBorder(new javax.swing.border.EtchedBorder());
          
          boxPanel.setLayout(new java.awt.GridBagLayout());
            java.awt.GridBagConstraints gridBagConstraints1;
            
            
              java.awt.GridBagConstraints gridBagConstraints2;
                lowerCornerPanel.setBorder(new javax.swing.border.TitledBorder("Lower"));
                jPanel3.add(lowerCornerPanel);
                
                gridBagConstraints1 = new java.awt.GridBagConstraints();
              boxPanel.add(jPanel3, gridBagConstraints1);
              
              
            
              java.awt.GridBagConstraints gridBagConstraints3;
                upperCornerPanel.setBorder(new javax.swing.border.TitledBorder("Upper"));
                jPanel4.add(upperCornerPanel);
                
                gridBagConstraints1 = new java.awt.GridBagConstraints();
              boxPanel.add(jPanel4, gridBagConstraints1);
              
              cardPanel.add(boxPanel, "boxCard");
            
            
          spherePanel.setLayout(new java.awt.GridBagLayout());
            java.awt.GridBagConstraints gridBagConstraints4;
            
            radiusL.setText("Radius :");
              gridBagConstraints4 = new java.awt.GridBagConstraints();
              spherePanel.add(radiusL, gridBagConstraints4);
              
              
            radiusTF.setText("jTextField1");
              gridBagConstraints4 = new java.awt.GridBagConstraints();
              gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
              spherePanel.add(radiusTF, gridBagConstraints4);
              
              
            centerL.setText("Center :");
              gridBagConstraints4 = new java.awt.GridBagConstraints();
              gridBagConstraints4.gridx = 0;
              gridBagConstraints4.gridy = 1;
              spherePanel.add(centerL, gridBagConstraints4);
              
              
            
              java.awt.GridBagConstraints gridBagConstraints5;
                jPanel1.add(centerPanel);
                
                gridBagConstraints4 = new java.awt.GridBagConstraints();
              gridBagConstraints4.gridx = 1;
              gridBagConstraints4.gridy = 1;
              spherePanel.add(jPanel1, gridBagConstraints4);
              
              cardPanel.add(spherePanel, "sphereCard");
            
            
          
            jLabel1.setText("Not Implemented");
              polytopePanel.add(jLabel1);
              
              cardPanel.add(polytopePanel, "polytopeCard");
            
            
          
            jLabel6.setText("Null Bounds");
              nullPanel.add(jLabel6);
              
              cardPanel.add(nullPanel, "nullCard");
            
            
          add(cardPanel, java.awt.BorderLayout.CENTER);
          
          
          
          boundsTypeC.addItemListener(new java.awt.event.ItemListener() {
                public void itemStateChanged(java.awt.event.ItemEvent evt) {
                    boundsTypeCItemStateChanged(evt);
                }
            }
            );
            jPanel2.add(boundsTypeC);
            
            
          showBoundsCB.setText("Show Bounds");
            showBoundsCB.addChangeListener(new javax.swing.event.ChangeListener() {
                public void stateChanged(javax.swing.event.ChangeEvent evt) {
                    showBoundsCBStateChanged(evt);
                }
            }
            );
            jPanel2.add(showBoundsCB);
            
            
          add(jPanel2, java.awt.BorderLayout.NORTH);
          
  }//GEN-END:initComponents

  private void showBoundsCBStateChanged (javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_showBoundsCBStateChanged
// Add your handling code here:
    changeListener.showBounds( this, showBoundsCB.isSelected() );
  }//GEN-LAST:event_showBoundsCBStateChanged

  private void boundsTypeCItemStateChanged (java.awt.event.ItemEvent evt) {//GEN-FIRST:event_boundsTypeCItemStateChanged
// Add your handling code here:
    switch( boundsTypeC.getSelectedIndex() ) {
      case 0:
        currentBounds = new BoundingSphere();
        break;
      case 1:
        currentBounds = new BoundingBox();
        break;
      case 2:
        currentBounds = new BoundingPolytope();
        break;
      case 3:
        currentBounds = null;
        break;
    }
    setControls();
    if (changeListener!=null)
      changeListener.boundsChanged( this, currentBounds );
    else 
      throw new RuntimeException("BoundPanel ChangeListener is null");
  }//GEN-LAST:event_boundsTypeCItemStateChanged

  /**
    * Set controls to represent currentBounds
    */
  private void setControls() {
    if (currentBounds==null) {
      cardLayout.show( cardPanel, "nullCard");
      boundsTypeC.setSelectedIndex( 3 );
    } else {
      if (currentBounds instanceof javax.media.j3d.BoundingSphere)
        processBoundingSphere();
      else if (currentBounds instanceof javax.media.j3d.BoundingBox)
        processBoundingBox();
      else if (currentBounds instanceof javax.media.j3d.BoundingPolytope)
        processBoundingPolytope();
    }
  }
  
  private void processBoundingSphere() {
    javax.media.j3d.BoundingSphere bSphere = (javax.media.j3d.BoundingSphere)currentBounds;
    cardLayout.show( cardPanel, "sphereCard" );
    boundsTypeC.setSelectedIndex( 0 );
    radiusTF.setText( Double.toString( bSphere.getRadius() ));
    Point3d center = new Point3d();
    bSphere.getCenter( center );
    centerPanel.setTuple( center );
  }
  
  private void processBoundingBox() {
    cardLayout.show( cardPanel, "boxCard" );
    boundsTypeC.setSelectedIndex( 1 );
    Point3d upperCorner = new Point3d();
    Point3d lowerCorner = new Point3d();
    ((BoundingBox)currentBounds).getUpper( upperCorner );
    ((BoundingBox)currentBounds).getLower( lowerCorner );
    upperCornerPanel.setTuple( upperCorner );
    lowerCornerPanel.setTuple( lowerCorner );
  }
  
  private void processBoundingPolytope() {
    cardLayout.show( cardPanel, "polytopeCard" );
    boundsTypeC.setSelectedIndex( 2 );
  }
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel cardPanel;
  private javax.swing.JPanel boxPanel;
  private javax.swing.JPanel jPanel3;
  private com.sun.j3d.demos.utils.gui.Tuple3dPanel lowerCornerPanel;
  private javax.swing.JPanel jPanel4;
  private com.sun.j3d.demos.utils.gui.Tuple3dPanel upperCornerPanel;
  private javax.swing.JPanel spherePanel;
  private javax.swing.JLabel radiusL;
  private javax.swing.JTextField radiusTF;
  private javax.swing.JLabel centerL;
  private javax.swing.JPanel jPanel1;
  private com.sun.j3d.demos.utils.gui.Tuple3dPanel centerPanel;
  private javax.swing.JPanel polytopePanel;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JPanel nullPanel;
  private javax.swing.JLabel jLabel6;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JComboBox boundsTypeC;
  private javax.swing.JCheckBox showBoundsCB;
  // End of variables declaration//GEN-END:variables

  /**
   * Called whenever the user changes the values in the Tuple3dPanel
   */
  public void pointChanged(Tuple3dPanel source,double x,double y,double z) {
    System.out.println("Tuple Changed "+source );
  }
}

