/*
 *  @(#)IntegerDocument.java 1.2 00/12/19 16:49:17
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.gui;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import java.awt.Toolkit;

/**
  * Class to ensure that a Textfield contains a valid Integer
  */
public class IntegerDocument extends javax.swing.text.PlainDocument {

  public void insertString( int offset, String s, AttributeSet attributeSet ) 
                                          throws BadLocationException {                                          
    try {
      StringBuffer buf = new StringBuffer( getText( 0, getLength() ));
      buf.insert( offset, s );
      if (offset==0 && s.equals("-")) {
        super.insertString( offset, s, attributeSet );
        return;
      }
      Integer.parseInt( buf.toString() );
    } catch(NumberFormatException e ) { // Only allow Integer values
      Toolkit.getDefaultToolkit().beep();
      return;
    }
    super.insertString(offset, s, attributeSet);
  }
}
