/*
 *  @(#)Tuple3dPanel.java 1.2 00/12/19 16:49:21
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.gui;

/**
 * @author Paul Byrne
 * @version	1.2, 12/19/00
 */
public class Tuple3dPanel extends javax.swing.JPanel {

  private Tuple3dChangeListener changeListener;
  private double origX;
  private double origY;
  private double origZ;
  
  
  /** Creates new form point3fPanel */
  public Tuple3dPanel() {
    initComponents ();
  }
  
  /**
    * Set the point on which this panel operates
    */
  public void setTuple( javax.vecmath.Tuple3d point ) {
    origX = point.x;
    origY = point.y;
    origZ = point.z;
    xTF.setText( Double.toString( point.x ));
    yTF.setText( Double.toString( point.y ));
    zTF.setText( Double.toString( point.z ));
  }
  
  public void setChangeListener( Tuple3dChangeListener changeListener ) {
    this.changeListener = changeListener;
  }
  
  public void setReadOnly( boolean readOnly ) {
    xTF.setEditable( !readOnly );
    yTF.setEditable( !readOnly );
    zTF.setEditable( !readOnly );
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
      jLabel1 = new javax.swing.JLabel();
      jLabel2 = new javax.swing.JLabel();
      jLabel3 = new javax.swing.JLabel();
      xTF = new javax.swing.JTextField();
      yTF = new javax.swing.JTextField();
      zTF = new javax.swing.JTextField();
      setLayout(new java.awt.GridBagLayout());
      java.awt.GridBagConstraints gridBagConstraints1;
      
      jLabel1.setText("X :");
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 3);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
      add(jLabel1, gridBagConstraints1);
      
      
      jLabel2.setText("Y :");
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 3);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
      add(jLabel2, gridBagConstraints1);
      
      
      jLabel3.setText("Z :");
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 2;
      gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 3);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
      add(jLabel3, gridBagConstraints1);
      
      
      xTF.setPreferredSize(new java.awt.Dimension(90, 21));
      xTF.setToolTipText("X coordinate (double)");
      xTF.setText("000000");
      xTF.setMinimumSize(new java.awt.Dimension(90, 21));
      xTF.setDocument(new FloatDocument());
      xTF.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              tfAction(evt);
          }
      }
      );
      xTF.addFocusListener(new java.awt.event.FocusAdapter() {
          public void focusLost(java.awt.event.FocusEvent evt) {
              tfFocusLost(evt);
          }
      }
      );
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
      add(xTF, gridBagConstraints1);
      
      
      yTF.setToolTipText("Y coordinate (double)");
      yTF.setText("000000");
      yTF.setMinimumSize(new java.awt.Dimension(40, 21));
      yTF.setDocument(new FloatDocument());
      yTF.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              tfAction(evt);
          }
      }
      );
      yTF.addFocusListener(new java.awt.event.FocusAdapter() {
          public void focusLost(java.awt.event.FocusEvent evt) {
              tfFocusLost(evt);
          }
      }
      );
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
      add(yTF, gridBagConstraints1);
      
      
      zTF.setToolTipText("Z coordinate (double)");
      zTF.setText("000000");
      zTF.setMinimumSize(new java.awt.Dimension(40, 21));
      zTF.setDocument(new FloatDocument());
      zTF.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              tfAction(evt);
          }
      }
      );
      zTF.addFocusListener(new java.awt.event.FocusAdapter() {
          public void focusLost(java.awt.event.FocusEvent evt) {
              tfFocusLost(evt);
          }
      }
      );
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.gridy = 2;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
      add(zTF, gridBagConstraints1);
      
  }//GEN-END:initComponents

  private void tfAction (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfAction
// Add your handling code here:
    processChange();
  }//GEN-LAST:event_tfAction

  private void tfFocusLost (java.awt.event.FocusEvent evt) {//GEN-FIRST:event_tfFocusLost
// Add your handling code here:
    processChange();
  }//GEN-LAST:event_tfFocusLost

  private void processChange() {
    try {
      double x = Double.parseDouble( xTF.getText() );
      double y = Double.parseDouble( yTF.getText() );
      double z = Double.parseDouble( zTF.getText() );
      if (x!=origX || y!=origY || z!=origZ) {
        changeListener.pointChanged( this, x, y, z );
        origX = x;
        origY = y;
        origZ = z;
      }
    } catch( NumberFormatException e ) {
      // Should never reach here because format is checked by FloatDocument
      e.printStackTrace();
    }
  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JTextField xTF;
  private javax.swing.JTextField yTF;
  private javax.swing.JTextField zTF;
  // End of variables declaration//GEN-END:variables

}

