/*
 *  @(#)WorkingDialog.java 1.6 01/03/02 14:02:36
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.gui;

/**
 * @author Paul Byrne
 * @version	1.6, 03/02/01
 */
public class WorkingDialog extends javax.swing.JDialog implements WorkMonitor {

    private int maxProgress=-1;
    private int currentProgress=0;
    
    /** Creates new form WorkMonitor */
    public WorkingDialog(java.awt.Frame parent ) {
        super (parent, false);
        initComponents ();
        pack ();
        
        setLocation( parent.getWidth()/2 - getWidth()/2,
                     parent.getHeight()/2 - getHeight()/2 );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        titleLabel = new javax.swing.JLabel();
        progressTF = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        setTitle("Loading....");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        jPanel1.setPreferredSize(new java.awt.Dimension(250, 80));
        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        jPanel1.setMinimumSize(new java.awt.Dimension(250, 80));
        
        titleLabel.setText("Loading, Please Wait...");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.insets = new java.awt.Insets(0, 6, 8, 0);
          jPanel1.add(titleLabel, gridBagConstraints1);
          
          
        progressTF.setColumns(5);
          progressTF.setText("jTextField1");
          progressTF.setMinimumSize(new java.awt.Dimension(57, 21));
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 0;
          gridBagConstraints1.gridy = 1;
          gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 4);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
          jPanel1.add(progressTF, gridBagConstraints1);
          
          
        jLabel1.setText("Elapsed time");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 1;
          gridBagConstraints1.gridy = 1;
          gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 6);
          jPanel1.add(jLabel1, gridBagConstraints1);
          
          
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    /**
     * Display a note about the current activity
    */
    public void setNote(String note) {
    }    

    /**
     * Indicate progress is being made
    */
    public void setProgress(int progress) {
        progressTF.setText( Integer.toString( progress ) );
        currentProgress = progress;
        toFront();
        if (currentProgress==maxProgress || currentProgress==-1) {
            setVisible( false );
            dispose();
        }
    }
    
    /**
     * Set the maximum size of the progress.
     *
     * When maxProgress is reached the dialog will be close
    */
    public void setMaxProgress(int maxProgress) {
        this.maxProgress = maxProgress;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel titleLabel;
    private javax.swing.JTextField progressTF;
    private javax.swing.JLabel jLabel1;
    // End of variables declaration//GEN-END:variables

}
