/*
 *  @(#)Help.java 1.6 00/12/19 16:50:28
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.help;

import java.net.URL;
import javax.help.*;

/**
 *
 * @author Paul Byrne
 * @version	1.6, 12/19/00
 */
public class Help extends java.lang.Object {

    private static HelpBroker helpBroker = null;
    private static HelpSet masterHS;

    /**
     * Initialize the help system. This MUST be called before GUI initialization
     * otherwise GUI components will not display their help buttons.
     *
     * @param masterHSname The name of the master helpSet
     */
    public static void initialize( String masterHSname ) {
        try {
            ClassLoader loader = com.sun.j3d.demos.utils.help.Help.class.getClassLoader();
            URL masterHSURL = HelpSet.findHelpSet( loader, masterHSname );
            masterHS = new HelpSet( loader , masterHSURL );

            //URL utilsHSURL = HelpSet.findHelpSet( loader, "com/sun/j3d/demos/utils/help/J3dUtilsHelp.hs" );
            //masterHS.add( new HelpSet( loader, utilsHSURL ) );
        } catch( Exception e ) {
            System.out.println("Helpset not found");
            return;
        }
        
        helpBroker = masterHS.createHelpBroker();
        
        helpBroker.initPresentation();
        
    }
    
    public static void addHelpButton( java.awt.Component button, String helpID ) {
        helpBroker.enableHelpOnButton( button, helpID, masterHS );
    }
    
    public static boolean isEnabled() {
        return (helpBroker==null) ? false : true;
    }
}
