/*
 *  @(#)LoaderControlListener.java 1.4 00/12/19 16:52:36
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.loadercontrol;

/** 
 * Listener which gets notified when SceneLoader has finished loading a
 * file
 * @author Paul Byrne
 * @version	1.4, 12/19/00
 */
public interface LoaderControlListener {
    
  /**
   * File was Loaded successfully
   */
  public static final int LOAD_COMPLETE=0; 
  
  /**
   * File load failed
   */
  public static final int LOAD_FAILED=1;
    
  /**
   * Called when the scene load is complete
   *
   * @param status Status of Load, either LOAD_COMPLETE or LOAD_FAILED
   * @param scene The scene that was loaded
   * @param loaderID The ID of the Loader used to load the scene
   * @param file The file from which the scene was loaded
   * @param loadException The exception (if any) thrown during the load 
   */
  public void sceneLoaded( int status, com.sun.j3d.loaders.Scene scene, int loaderID,
                            java.io.File file,
                            Exception loadException );
  
}
