/*
 *  @(#)SceneGraphObjectReferenceControl.java 1.3 00/12/19 17:22:01
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io;

/**
 * Provides and resolves references to SceneGraphObjects to enable
 * persistant references in user defined SceneGraphObjects implementing
 * the SceneGraphIO interface.
 *
 * @author  Paul Byrne
 * @version 1.3 12/19/00
 */
public interface SceneGraphObjectReferenceControl {
    
    /**
     * Add a reference to the scenegraph object specified and return
     * the nodeID for the object
     *
     * Use only during the save cycle
     */
    public int addReference( javax.media.j3d.SceneGraphObject object );

    /**
     * Given a nodeID return the corresponding scene graph object.
     *
     * Use only during the load cycle
     */
    public javax.media.j3d.SceneGraphObject resolveReference( int nodeID );
}

