/*
 *  @(#)SceneGraphStreamReader.java 1.4 00/12/19 17:22:05
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io;

import java.io.InputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.util.HashMap;

import javax.media.j3d.VirtualUniverse;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.SceneGraphObject;
import com.sun.j3d.demos.utils.scenegraph.io.retained.StreamControl;

/**
 * Read and create a (set) of Java3D BranchGraphs or Universe from a Java Stream.
 *
 * @author Paul Byrne
 * @version	1.4, 12/19/00
 */
public class SceneGraphStreamReader extends java.lang.Object {
    
    private StreamControl control;
    private DataInputStream in;

    /** Creates new SceneGraphStreamReader and reads the file header information */
    public SceneGraphStreamReader( InputStream stream ) throws IOException {
        in = new DataInputStream( stream );
        control = new StreamControl( in );
    }
    
    /**
     * Read and create the universe. If the BranchGraphs were written then
     * they will be added to the universe before it is returned.
     */
    public VirtualUniverse readUniverse() throws IOException {
        return control.readUniverse(in, true);
    }
    
    /**
     * Read and return the graph from the stream.
     * <code>namedObjects</code> map will be updated with any objects that
     * were named during the write process
     */
    public BranchGroup readBranchGraph( HashMap namedObjects ) throws IOException {
        return control.readBranchGraph( namedObjects );
    }
  
}

