/*
 *  @(#)NcFont3D.java 1.3 00/12/19 16:58:24
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.retained;


import java.util.HashMap;
import javax.media.j3d.Font3D;
import javax.media.j3d.FontExtrusion;

/**
 * Force a Font3D to look like a NodeComponent so we can use the
 * standard scenegraph.io mechanisms to support sharing etc.
 * 
 *
 * @author  Paul Byrne
 * @version 1.3 12/19/00
 */
public class NcFont3D extends javax.media.j3d.NodeComponent {

    private Font3D font3D;
    
    private static HashMap objectMap = new HashMap();
    
    /** Creates new NcFont3D */
    public NcFont3D( Font3D font ) {
        font3D = font;
    }
    
    public NcFont3D( java.awt.Font font, double tessellationTolerance, FontExtrusion extrudePath ) {
        font3D = new Font3D( font, tessellationTolerance, extrudePath );
    }
    
    public static NcFont3D getNcFont3D( Font3D font3D ) {
        NcFont3D ret = (NcFont3D)objectMap.get( font3D );
        
        if (ret==null) {
            ret = new NcFont3D( font3D );
            objectMap.put( font3D, ret );
        }
        
        return ret;
    }
    
    public Font3D getFont3D() {
        return font3D;
    }
    
    public java.awt.Font getFont() {
        return font3D.getFont();
    }
    
    public void getFontExtrusion( FontExtrusion extrudePath ) {
        font3D.getFontExtrusion( extrudePath );
    }
    
    public double getTessellationTolerance() {
        return font3D.getTessellationTolerance();
    }

}
