/*
 *  @(#)ColorCubeState.java 1.4 00/12/19 17:02:04
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.com.sun.j3d.utils.geometry;

import java.io.*;
import com.sun.j3d.utils.geometry.ColorCube;
import javax.media.j3d.Shape3D;
import javax.media.j3d.SceneGraphObject;
import javax.vecmath.Color3f;
import com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d.Shape3DState;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.4, 12/19/00
 *
 */
public class ColorCubeState extends Shape3DState {
    
    private double scale=1.0;

    public ColorCubeState(SymbolTableData symbol,Controller control) {
	super( symbol, control );
        
    }

    public void writeConstructorParams( DataOutput out ) throws IOException {
	super.writeConstructorParams( out );
        
        out.writeDouble( ((ColorCube)node).getScale() );
        
    }

    public void readConstructorParams( DataInput in ) throws IOException {
       super.readConstructorParams(in);
       
       scale = in.readDouble();
    }
    
    /**
    * Returns true if the groups children should be saved.
    *
    * This is overridden by 'black box' groups such a geometry primitives
    */
    protected boolean processChildren() {
        return false;
    }
  
    public SceneGraphObject createNode( Class j3dClass ) {
        Shape3D shape = (Shape3D) createNode( j3dClass, new Class[]{ Double.TYPE }, new Object[] { new Double(scale) } );

        return shape;
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new ColorCube( scale );
    }

    
}
