/*
 *  @(#)PrimitiveState.java 1.4 00/12/19 17:02:08
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.com.sun.j3d.utils.geometry;

import java.io.*;
import com.sun.j3d.utils.geometry.Primitive;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d.GroupState;

/**
 * @author Paul Byrne
 * @version	1.4, 12/19/00
 *
 */
public class PrimitiveState extends GroupState {
    
    protected int primflags;

    public PrimitiveState( SymbolTableData symbol, Controller control ) {
	super( symbol, control );
        
    }

    public void writeConstructorParams( DataOutput out ) throws IOException {
	super.writeConstructorParams( out );
        
        out.writeInt( ((Primitive)node).getPrimitiveFlags() );
    }

    public void readConstructorParams( DataInput in ) throws IOException {
       super.readConstructorParams(in);
       
       primflags = in.readInt();
    }
    
    public void buildGraph() {        
        super.buildGraph();
    }
    
  /**
   * Returns true if the groups children should be saved.
   *
   * This is overridden by 'black box' groups such a geometry primitives
   */
  protected boolean processChildren() {
      return false;
  }
}
