/*
 *  @(#)AlphaState.java 1.4 01/03/02 15:33:56
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Alpha;

public class AlphaState extends NodeComponentState {
    
    public AlphaState(SymbolTableData symbol,Controller control) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        Alpha alpha = (Alpha)node;
        out.writeLong( alpha.getAlphaAtOneDuration() );
        out.writeLong( alpha.getAlphaAtZeroDuration() );
        out.writeLong( alpha.getDecreasingAlphaDuration() );
        out.writeLong( alpha.getDecreasingAlphaRampDuration() );
        out.writeLong( alpha.getIncreasingAlphaDuration() );
        out.writeLong( alpha.getIncreasingAlphaRampDuration() );
        out.writeInt( alpha.getLoopCount() );
        out.writeInt( alpha.getMode() );
        out.writeLong( alpha.getPhaseDelayDuration() );
        out.writeLong( alpha.getStartTime() );
        out.writeLong( alpha.getTriggerTime() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        Alpha alpha = (Alpha)node;
        alpha.setAlphaAtOneDuration( in.readLong() );
        alpha.setAlphaAtZeroDuration( in.readLong() );
        alpha.setDecreasingAlphaDuration( in.readLong() );
        alpha.setDecreasingAlphaRampDuration( in.readLong() );
        alpha.setIncreasingAlphaDuration( in.readLong() );
        alpha.setIncreasingAlphaRampDuration( in.readLong() );
        alpha.setLoopCount( in.readInt() );
        alpha.setMode( in.readInt() );
        alpha.setPhaseDelayDuration( in.readLong() );
        alpha.setStartTime( in.readLong() );
        alpha.setTriggerTime( in.readLong() );
    }
    
    protected SceneGraphObject createNode() {
        return new Alpha();
    }
}

