/*
 *  @(#)AlternateAppearanceState.java 1.4 01/03/02 15:34:42
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.AlternateAppearance;
import javax.media.j3d.BoundingLeaf;
import javax.media.j3d.Appearance;
import javax.media.j3d.Group;

public class AlternateAppearanceState extends LeafState {
    
    private int[] scopes;
    private int appearance;
    private int influencingBoundingLeaf;
    
    public AlternateAppearanceState(SymbolTableData symbol,Controller control) {
        super(symbol, control);
        
        if (node!=null) {
            scopes = new int[ ((AlternateAppearance)node).numScopes() ];
            for(int i=0; i<scopes.length; i++)
                scopes[i] = control.getSymbolTable().addReference( ((AlternateAppearance)node).getScope(i));

            appearance = control.getSymbolTable().addReference( ((AlternateAppearance)node).getAppearance());
            influencingBoundingLeaf = control.getSymbolTable().addReference( ((AlternateAppearance)node).getInfluencingBoundingLeaf());
        }
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( scopes.length );
        for(int i=0; i<scopes.length; i++)
            out.writeInt( scopes[i] );
        
        out.writeInt( appearance );
        out.writeInt( influencingBoundingLeaf );
        control.writeBounds( out, ((AlternateAppearance)node).getInfluencingBounds() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
        scopes = new int[ in.readInt() ];
        for(int i=0; i<scopes.length; i++)
            scopes[i] = in.readInt();
        
        appearance = in.readInt();
        influencingBoundingLeaf = in.readInt();
        
        ((AlternateAppearance)node).setInfluencingBounds( control.readBounds(in));
    }
    
    public void buildGraph() {
        for(int i=0; i<scopes.length; i++)
            ((AlternateAppearance)node).addScope( (Group)control.getSymbolTable().getJ3dNode( scopes[i] ));
        
        ((AlternateAppearance)node).setAppearance( (Appearance)control.getSymbolTable().getJ3dNode( appearance ));
        ((AlternateAppearance)node).setInfluencingBoundingLeaf( (BoundingLeaf)control.getSymbolTable().getJ3dNode( influencingBoundingLeaf ));
        
    }
    
    protected SceneGraphObject createNode() {
        return new AlternateAppearance();
    }
}

