/*
 *  @(#)AuralAttributesState.java 1.3 01/03/02 15:34:38
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.AuralAttributes;
import javax.media.j3d.SceneGraphObject;
import javax.vecmath.Vector3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.3 03/02/01
 */
public class AuralAttributesState extends NodeComponentState {

    public AuralAttributesState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeFloat( ((AuralAttributes)node).getAttributeGain() );
        
        float[] distance = new float[ ((AuralAttributes)node).getDistanceFilterLength() ];
        float[] cutoff = new float[ distance.length ];
        
        ((AuralAttributes)node).getDistanceFilter( distance, cutoff );
        out.writeInt( distance.length );
        for(int i=0; i<distance.length; i++) {
            out.writeFloat( distance[i] );
            out.writeFloat( cutoff[i] );
        }
        
        out.writeFloat( ((AuralAttributes)node).getFrequencyScaleFactor() );
        out.writeFloat( ((AuralAttributes)node).getReflectionCoefficient() );
        control.writeBounds( out, ((AuralAttributes)node).getReverbBounds() );
        out.writeFloat( ((AuralAttributes)node).getReverbDelay() );
        out.writeInt( ((AuralAttributes)node).getReverbOrder() );
        out.writeFloat( ((AuralAttributes)node).getRolloff() );
        out.writeFloat( ((AuralAttributes)node).getVelocityScaleFactor() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
                    
        ((AuralAttributes)node).setAttributeGain( in.readFloat() );
        
        float[] distance = new float[ in.readInt() ];
        float[] cutoff = new float[ distance.length ];
        for(int i=0; i<distance.length; i++) {
            distance[i] = in.readFloat();
            cutoff[i] = in.readFloat();
        }
        ((AuralAttributes)node).setDistanceFilter( distance, cutoff );
        
        ((AuralAttributes)node).setFrequencyScaleFactor( in.readFloat() );
        ((AuralAttributes)node).setReflectionCoefficient( in.readFloat() );
        ((AuralAttributes)node).setReverbBounds( control.readBounds(in) );
        ((AuralAttributes)node).setReverbDelay( in.readFloat() );
        ((AuralAttributes)node).setReverbOrder( in.readInt() );
        ((AuralAttributes)node).setRolloff( in.readFloat() );
        ((AuralAttributes)node).setVelocityScaleFactor( in.readFloat() );
    }
    
    protected SceneGraphObject createNode() {
        return new AuralAttributes();
    }
    
}
