/*
 *  @(#)BackgroundState.java 1.4 01/03/02 15:34:43
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Background;
import javax.media.j3d.BoundingLeaf;
import javax.media.j3d.Appearance;
import javax.media.j3d.ImageComponent2D;
import javax.media.j3d.BranchGroup;
import javax.vecmath.Color3f;

public class BackgroundState extends LeafState {
    
    private int image;
    private int boundingLeaf;
    private int geometry;
    
    public BackgroundState(SymbolTableData symbol,Controller control) {
        super(symbol, control);
        
        if (node!=null) {
            boundingLeaf = control.getSymbolTable().addReference( ((Background)node).getApplicationBoundingLeaf());
            geometry =  control.getSymbolTable().addReference( ((Background)node).getGeometry());
            image = control.getSymbolTable().addReference( ((Background)node).getImage());
        }
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( boundingLeaf );
        out.writeInt( geometry );
        out.writeInt( image );
        control.writeBounds( out, ((Background)node).getApplicationBounds() );
        Color3f clr = new Color3f();
        ((Background)node).getColor(clr);
        control.writeColor3f( out, clr );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
        boundingLeaf = in.readInt();
        geometry = in.readInt();
        image = in.readInt();
        
        ((Background)node).setApplicationBounds( control.readBounds(in));
        ((Background)node).setColor( control.readColor3f(in));
        
    }
    
    public void buildGraph() {
        ((Background)node).setApplicationBoundingLeaf( (BoundingLeaf)control.getSymbolTable().getJ3dNode( boundingLeaf ));
        ((Background)node).setGeometry( (BranchGroup)control.getSymbolTable().getJ3dNode( geometry ));
        ((Background)node).setImage( (ImageComponent2D)control.getSymbolTable().getJ3dNode( image ));
        
    }
    
    protected SceneGraphObject createNode() {
        return new Background();
    }
    
}

