/*
 *  @(#)BehaviorState.java 1.5 01/03/02 15:34:00
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.Behavior;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.BoundingLeaf;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.5, 03/02/01
 */
public abstract class BehaviorState extends LeafState {

    private int boundingLeaf;
    
    public BehaviorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        Behavior beh = (Behavior)node;
        
        out.writeBoolean( beh.getEnable() );
        out.writeInt( control.getSymbolTable().addReference( beh.getSchedulingBoundingLeaf() ) );
        
        control.writeBounds( out, beh.getSchedulingBounds() );
        
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        Behavior beh = (Behavior)node;
        
        beh.setEnable( in.readBoolean() );
        boundingLeaf = in.readInt();
        beh.setSchedulingBounds( control.readBounds( in ));

    }
    
    public void buildGraph() {
        super.buildGraph();
        ((Behavior)node).setSchedulingBoundingLeaf( (BoundingLeaf)control.getSymbolTable().getJ3dNode( boundingLeaf ));
    }

}
