/*
 *  @(#)BillboardState.java 1.4 01/03/02 15:34:44
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.Billboard;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.4 03/02/01
 */
public class BillboardState extends BehaviorState {
    
    private int target;
    
    public BillboardState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null)
            target = control.getSymbolTable().addReference( ((Billboard)node).getTarget() );
        
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( ((Billboard)node).getAlignmentMode() );
        
        Vector3f vec = new Vector3f();
        ((Billboard)node).getAlignmentAxis( vec );
        
        Point3f point = new Point3f();
        ((Billboard)node).getRotationPoint( point );
        
        control.writeVector3f( out, vec );
        control.writePoint3f( out, point );
        
        out.writeInt( target );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
          
        ((Billboard)node).setAlignmentMode( in.readInt() );
        ((Billboard)node).setAlignmentAxis( control.readVector3f( in ) );
        ((Billboard)node).setRotationPoint( control.readPoint3f( in ) );
        
        target = in.readInt();
    }
        
    public void buildGraph() {
        ((Billboard)node).setTarget( (TransformGroup)control.getSymbolTable().getJ3dNode( target ));
    }
    
    protected SceneGraphObject createNode() {
        return new Billboard();
    }
}
