/*
 *  @(#)BoundingLeafState.java 1.4 01/03/02 15:34:35
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.*;
import javax.media.j3d.BoundingLeaf;
import javax.media.j3d.Bounds;
import javax.media.j3d.BoundingBox;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.BoundingPolytope;
import javax.media.j3d.NodeComponent;
import javax.media.j3d.SceneGraphObject;
import javax.vecmath.Point3d;
import javax.vecmath.Vector4d;

import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

public abstract class BoundingLeafState extends SceneGraphObjectState {

    public BoundingLeafState(SymbolTableData symbol,Controller control) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws 
							IOException {

        super.writeObject( out );
        
        control.writeBounds( out, ((BoundingLeaf)node).getRegion() );        
    }

    public void readObject( DataInput in ) throws
							IOException {
       super.readObject(in);

       ((BoundingLeaf)node).setRegion( control.readBounds(in) );
    }
    
    protected SceneGraphObject createNode() {
        return new BoundingLeaf();
    }

}

