/*
 *  @(#)ClipState.java 1.3 00/12/19 17:16:30
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.Clip;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.BoundingLeaf;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.3, 12/19/00
 */
public abstract class ClipState extends LeafState {

    private int boundingLeaf;
    
    public ClipState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null)
            boundingLeaf = control.getSymbolTable().addReference( ((Clip)node).getApplicationBoundingLeaf() );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        out.writeInt( boundingLeaf );
        control.writeBounds( out, ((Clip)node).getApplicationBounds() );
        out.writeDouble( ((Clip)node).getBackDistance() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        boundingLeaf = in.readInt();
        ((Clip)node).setApplicationBounds( control.readBounds( in ));
        ((Clip)node).setBackDistance( in.readDouble() );
    }
    
    public void buildGraph() {
        super.buildGraph();
        
        ((Clip)node).setApplicationBoundingLeaf( (BoundingLeaf)control.getSymbolTable().getJ3dNode( boundingLeaf ));
    }
    
}
