/*
 *  @(#)ColorInterpolatorState.java 1.4 01/03/02 15:34:40
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.ColorInterpolator;
import javax.media.j3d.Material;
import javax.media.j3d.SceneGraphObject;
import javax.vecmath.Color3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.4 03/02/01
 */
public class ColorInterpolatorState extends InterpolatorState {

    private int target;
    
    public ColorInterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null)
            target = control.getSymbolTable().addReference( ((ColorInterpolator)node).getTarget() );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( target );
        Color3f clr = new Color3f();
        ((ColorInterpolator)node).getStartColor( clr );
        control.writeColor3f( out, clr );
        ((ColorInterpolator)node).getEndColor( clr );
        control.writeColor3f( out, clr );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
                        
        target = in.readInt();
        ((ColorInterpolator)node).setStartColor( control.readColor3f( in ) );
        ((ColorInterpolator)node).setEndColor( control.readColor3f( in ) );
    }
    
    
    public void buildGraph() {
        super.buildGraph();
        
        ((ColorInterpolator)node).setTarget( (Material)control.getSymbolTable().getJ3dNode( target ));
    }
    
    public SceneGraphObject createNode( Class j3dClass ) {
        return createNode( j3dClass, new Class[] { javax.media.j3d.Alpha.class,
                                                    javax.media.j3d.Material.class },
                                      new Object[] { null,
                                                     null } );
                                                    
    }
    
    protected SceneGraphObject createNode() {
        return new ColorInterpolator( null, null );
    }


}
