/*
 *  @(#)ColoringAttributesState.java 1.4 01/03/02 15:34:03
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.ColoringAttributes;
import javax.vecmath.Color3f;

public class ColoringAttributesState extends NodeComponentState {
    
    public ColoringAttributesState( SymbolTableData symbol, Controller control ) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        ColoringAttributes attr = (ColoringAttributes)node;
        Color3f clr = new Color3f();
        attr.getColor( clr );
        control.writeColor3f( out, clr );
        out.writeInt( attr.getShadeModel() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        ColoringAttributes attr = (ColoringAttributes)node;
        attr.setColor( control.readColor3f(in) );
        attr.setShadeModel( in.readInt() );
    }
    
    protected SceneGraphObject createNode() {
        return new ColoringAttributes();
    }

    
}

