/*
 *  @(#)DirectionalLightState.java 1.4 01/03/02 15:34:03
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.*;
import javax.media.j3d.DirectionalLight;
import javax.vecmath.Vector3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.4, 03/02/01
 */
public class DirectionalLightState extends LightState {

    public DirectionalLightState( SymbolTableData symbol, Controller control ) {
	super( symbol, control );

    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
	Vector3f dir = new Vector3f();
	((DirectionalLight)node).getDirection( dir );

	control.writeVector3f( out, dir );
    }

    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
	((DirectionalLight)node).setDirection( control.readVector3f(in) );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new DirectionalLight();
    }

}
