/*
 *  @(#)FogState.java 1.3 00/12/19 17:16:38
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.*;
import javax.media.j3d.Fog;
import javax.media.j3d.BoundingLeaf;
import javax.media.j3d.Group;
import javax.media.j3d.NodeComponent;
import javax.media.j3d.SceneGraphObject;
import javax.vecmath.Color3f;

import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

public abstract class FogState extends SceneGraphObjectState {

    protected int[] scopes;
    protected int boundingLeaf;
    
    public FogState(SymbolTableData symbol,Controller control) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws 
							IOException {

        super.writeObject( out );
        
        control.writeBounds( out, ((Fog)node).getInfluencingBounds() );     
        
        out.writeInt( ((Fog)node).numScopes() );
        for(int i=0; i<((Fog)node).numScopes(); i++)
            out.writeInt( control.getSymbolTable().addReference( ((Fog)node).getScope(i) ) );

        out.writeInt( control.getSymbolTable().addReference( ((Fog)node).getInfluencingBoundingLeaf() ));

        Color3f clr = new Color3f();
       ((Fog)node).getColor( clr );
       
       control.writeColor3f( out, clr );
    }

    public void readObject( DataInput in ) throws
							IOException {
       super.readObject(in);

       ((Fog)node).setInfluencingBounds( control.readBounds(in) );
       scopes = new int[ in.readInt() ];
       for(int i=0; i<scopes.length; i++)
           scopes[i] = in.readInt();
       
       boundingLeaf = in.readInt();
       ((Fog)node).setColor( control.readColor3f(in) );
    }
    
    public void buildGraph() {
        for(int i=0; i<scopes.length; i++)
            ((Fog)node).addScope( (Group)control.getSymbolTable().getJ3dNode( scopes[i] ) );

        ((Fog)node).setInfluencingBoundingLeaf( (BoundingLeaf)control.getSymbolTable().getJ3dNode( boundingLeaf ) );
    }

}

