/*
 *  @(#)GeometryStripArrayState.java 1.3 00/12/19 17:16:41
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.*;
import javax.media.j3d.GeometryStripArray;
import javax.media.j3d.SceneGraphObject;
import javax.vecmath.*;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.3, 12/19/00
 */
public abstract class GeometryStripArrayState extends GeometryArrayState {

    protected int[] stripVertexCounts;
    
    public GeometryStripArrayState( SymbolTableData symbol, Controller control ) {
	super( symbol, control );
    }

    protected void writeConstructorParams( DataOutput out ) throws
								IOException {
        super.writeConstructorParams( out ); 
        
	stripVertexCounts = new int[((GeometryStripArray)node).getNumStrips()];
        ((GeometryStripArray)node).getStripVertexCounts( stripVertexCounts );
        
	out.writeInt(stripVertexCounts.length);
        for(int i=0; i<stripVertexCounts.length; i++)
            out.writeInt( stripVertexCounts[i] );
    }

    protected void readConstructorParams( DataInput in ) throws
							IOException {
       super.readConstructorParams( in );
       stripVertexCounts = new int[in.readInt()];
       for(int i=0; i<stripVertexCounts.length; i++)
           stripVertexCounts[i] = in.readInt();
    }
}
