/*
 *  @(#)ImageComponent2DState.java 1.9 01/03/02 15:34:33
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInput;
import java.io.DataOutput;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.awt.Point;
import java.awt.image.*;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.ImageComponent2D;

import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

import javax.swing.*;
import java.awt.*;

public class ImageComponent2DState extends ImageComponentState {

    private BufferedImage bufferedImage;
    
    public ImageComponent2DState( SymbolTableData symbol, Controller control ) {
	super( symbol, control );
    }

    public void writeConstructorParams( DataOutput out ) throws 
							IOException {
        super.writeConstructorParams( out );    
        
        writeBufferedImage( out, ((ImageComponent2D)node).getImage() );
    }

    public void readConstructorParams( DataInput in ) throws
							IOException {

       super.readConstructorParams( in ); 
       
       bufferedImage = readBufferedImage( in );
       
    }

    protected SceneGraphObject createNode( Class j3dClass ) {
        return super.createNode( j3dClass, new Class[] { Integer.TYPE,
                                                          bufferedImage.getClass(),
                                                          Boolean.TYPE,
                                                          Boolean.TYPE },
                                            new Object[] { new Integer(format),
                                                           bufferedImage,
                                                           new Boolean( byReference ),
                                                           new Boolean( yUp ) } );
    }
    
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new ImageComponent2D( format, bufferedImage, byReference, yUp );
    }


}
