/*
 *  @(#)ImageComponent3DState.java 1.5 01/03/02 15:34:42
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInput;
import java.io.DataOutput;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.awt.Point;
import java.awt.image.*;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.ImageComponent3D;

import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

import javax.swing.*;
import java.awt.*;

public class ImageComponent3DState extends ImageComponentState {

    private BufferedImage[] bufferedImages;
    
    public ImageComponent3DState(SymbolTableData symbol,Controller control) {
	super( symbol, control );
    }

    public void writeConstructorParams( DataOutput out ) throws 
							IOException {
        super.writeConstructorParams( out );
               
        bufferedImages = ((ImageComponent3D)node).getImage();
        out.writeInt( bufferedImages.length );
        
        for(int i=0; i<bufferedImages.length; i++)
            writeBufferedImage( out, bufferedImages[i] );
    }

    public void readConstructorParams( DataInput in ) throws
							IOException {

       super.readConstructorParams( in );  
       
        bufferedImages = new BufferedImage[ in.readInt() ];
        for(int i=0; i<bufferedImages.length; i++)
            bufferedImages[i] = readBufferedImage( in );
       
       /*
	// Debug code to show the original images
	JFrame f = new JFrame();
	JPanel p = new JPanel() {
	    public void paint(Graphics g ) {
		super.paint(g);
		g.drawImage( bufferedImage, 10, 10, null );
	    }

	};

	f.getContentPane().add(p);
	f.setSize( 200, 200 );
	f.show();
        **/
    }

    protected SceneGraphObject createNode( Class j3dClass ) {
	return super.createNode( j3dClass, new Class[] { Integer.TYPE,
                                                          bufferedImages.getClass(),
                                                          Boolean.TYPE,
                                                          Boolean.TYPE },
                                            new Object[] { new Integer(format),
                                                           bufferedImages,
                                                           new Boolean( byReference ),
                                                           new Boolean( yUp ) } );
    }
    
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new ImageComponent3D( format, bufferedImages, byReference, yUp );
    }


}
