/*
 *  @(#)IndexedGeometryStripArrayState.java 1.3 00/12/19 17:16:46
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.*;
import javax.media.j3d.IndexedGeometryStripArray;
import javax.media.j3d.SceneGraphObject;
import javax.vecmath.*;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.3, 12/19/00
 */
public abstract class IndexedGeometryStripArrayState extends IndexedGeometryArrayState {

    protected int[] stripIndexCounts;
    
    public IndexedGeometryStripArrayState(SymbolTableData symbol,Controller control) {
	super( symbol, control );
    }

    protected void writeConstructorParams( DataOutput out ) throws
								IOException {
        super.writeConstructorParams( out ); 
        
	stripIndexCounts = new int[((IndexedGeometryStripArray)node).getNumStrips()];
        ((IndexedGeometryStripArray)node).getStripIndexCounts( stripIndexCounts );
        
	out.writeInt(stripIndexCounts.length);
        for(int i=0; i<stripIndexCounts.length; i++)
            out.writeInt( stripIndexCounts[i] );
    }

    protected void readConstructorParams( DataInput in ) throws
							IOException {
       super.readConstructorParams( in );
       stripIndexCounts = new int[in.readInt()];
       for(int i=0; i<stripIndexCounts.length; i++)
           stripIndexCounts[i] = in.readInt();
    }
}
