/*
 *  @(#)InterpolatorState.java 1.4 01/03/02 15:34:08
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.Interpolator;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Alpha;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.4, 03/02/01
 */
public abstract class InterpolatorState extends BehaviorState {

    private int alpha;
    
    public InterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        out.writeInt( control.getSymbolTable().addReference( ((Interpolator)node).getAlpha() ));
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        alpha = in.readInt();

    }
    
    public void buildGraph() {
        super.buildGraph();
        ((Interpolator)node).setAlpha( (Alpha)control.getSymbolTable().getJ3dNode( alpha ));
    }

}
