/*
 *  @(#)LineAttributesState.java 1.4 01/03/02 15:34:14
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.LineAttributes;

public class LineAttributesState extends NodeComponentState {
    
    public LineAttributesState( SymbolTableData symbol, Controller control ) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        LineAttributes attr = (LineAttributes)node;
        out.writeBoolean( attr.getLineAntialiasingEnable() );
        out.writeInt( attr.getLinePattern() );
        out.writeFloat( attr.getLineWidth() );
        out.writeInt( attr.getPatternMask() );
        out.writeInt( attr.getPatternScaleFactor() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        LineAttributes attr = (LineAttributes)node;
        attr.setLineAntialiasingEnable( in.readBoolean() );
        attr.setLinePattern( in.readInt() );
        attr.setLineWidth( in.readFloat() );
        attr.setPatternMask( in.readInt() );
        attr.setPatternScaleFactor( in.readInt() );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new LineAttributes();
    }

    
}

