/*
 *  @(#)LinearFogState.java 1.4 01/03/02 15:34:33
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.LinearFog;
import javax.media.j3d.SceneGraphObject;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.4, 03/02/01
 */
public class LinearFogState extends FogState {

    public LinearFogState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
                
        out.writeDouble( ((LinearFog)node).getBackDistance() );
        out.writeDouble( ((LinearFog)node).getFrontDistance() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
        ((LinearFog)node).setBackDistance( in.readDouble() );
        ((LinearFog)node).setFrontDistance( in.readDouble() );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new LinearFog();
    }

    
}
