/*
 *  @(#)LinkState.java 1.6 01/03/02 15:34:13
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import javax.media.j3d.Link;
import javax.media.j3d.SharedGroup;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.6, 03/02/01
 */
public class LinkState extends LeafState {

    private int sharedGroup;
    private SymbolTableData sharedGroupSymbol;
    
    /** Creates new BranchGroupState */
    public LinkState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        if (node!=null) {
            SharedGroup sg = ((Link)node).getSharedGroup();
            sharedGroup = control.getSymbolTable().addReference( sg );
            sharedGroupSymbol = control.getSymbolTable().getSymbol( sharedGroup );
        }
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        if (sharedGroupSymbol.nodeState==null) {
            out.writeInt( -1 );
            SharedGroup sg = ((Link)node).getSharedGroup();
            control.writeSharedGroup( out, sg, sharedGroupSymbol );
        } else {
            out.writeInt( sharedGroupSymbol.nodeID );
        }
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        sharedGroup = in.readInt();
        
        if (sharedGroup==-1) {
            sharedGroup = control.readSharedGroup( in );
        }
    }
    
    public void buildGraph() {
        super.buildGraph();
        sharedGroupSymbol = control.getSymbolTable().getSymbol( sharedGroup );
        ((SharedGroupState)sharedGroupSymbol.nodeState).buildGraph();
        ((Link)node).setSharedGroup( (SharedGroup)sharedGroupSymbol.j3dNode );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new Link();
    }


}
