/*
 *  @(#)MaterialState.java 1.4 01/03/02 15:34:17
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Material;
import javax.vecmath.Color3f;

public class MaterialState extends NodeComponentState {
    
    public MaterialState( SymbolTableData symbol, Controller control ) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        Material attr = (Material)node;
        Color3f clr = new Color3f();
        attr.getAmbientColor( clr );
        control.writeColor3f( out, clr );
        attr.getDiffuseColor( clr );
        control.writeColor3f( out, clr );
        attr.getEmissiveColor( clr );
        control.writeColor3f( out, clr );
        attr.getSpecularColor( clr );
        control.writeColor3f( out, clr );
        
        out.writeBoolean( attr.getLightingEnable() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        Material attr = (Material)node;
        attr.setAmbientColor( control.readColor3f( in ) );
        attr.setDiffuseColor( control.readColor3f( in ) );
        attr.setEmissiveColor( control.readColor3f( in ) );
        attr.setSpecularColor( control.readColor3f( in ) );
        attr.setLightingEnable( in.readBoolean() );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new Material();
    }

    
}

