/*
 *  @(#)MediaContainerState.java 1.3 01/03/02 15:34:37
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.MediaContainer;
import javax.media.j3d.SceneGraphObject;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.3 03/02/01
 */
public class MediaContainerState extends NodeComponentState {

    public MediaContainerState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeBoolean( ((MediaContainer)node).getCacheEnable() );
        out.writeUTF( ((MediaContainer)node).getURLString() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
        ((MediaContainer)node).setCacheEnable( in.readBoolean() );
        ((MediaContainer)node).setURLString( in.readUTF() );
    }    
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new MediaContainer();
    }


}
