/*
 *  @(#)NodeState.java 1.4 00/12/19 17:17:06
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.*;
import javax.media.j3d.Node;
import javax.media.j3d.NodeComponent;
import javax.media.j3d.SceneGraphObject;

import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

public abstract class NodeState extends SceneGraphObjectState {

    public NodeState( SymbolTableData symbol, Controller control ) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws 
							IOException {

        super.writeObject( out );
        
        control.writeBounds( out, ((Node)node).getBounds() );

	out.writeBoolean( ((Node)node).getPickable() );
	out.writeBoolean( ((Node)node).getCollidable() );
	out.writeBoolean( ((Node)node).getBoundsAutoCompute() );
        
    }

    public void readObject( DataInput in ) throws
							IOException {
       super.readObject(in);

       ((Node)node).setBounds( control.readBounds(in) );
       
       ((Node)node).setPickable( in.readBoolean() );
       ((Node)node).setCollidable( in.readBoolean() );
       ((Node)node).setBoundsAutoCompute( in.readBoolean() );
    }
    

    
}

