/*
 *  @(#)OrientedShape3DState.java 1.3 01/03/02 15:34:41
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.OrientedShape3D;
import javax.media.j3d.SceneGraphObject;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.3 03/02/01
 */
public class OrientedShape3DState extends Shape3DState {
    
    public OrientedShape3DState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( ((OrientedShape3D)node).getAlignmentMode() );
        
        Vector3f vec = new Vector3f();
        ((OrientedShape3D)node).getAlignmentAxis( vec );
        
        Point3f point = new Point3f();
        ((OrientedShape3D)node).getRotationPoint( point );
        
        control.writeVector3f( out, vec );
        control.writePoint3f( out, point );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
          
        ((OrientedShape3D)node).setAlignmentMode( in.readInt() );
        ((OrientedShape3D)node).setAlignmentAxis( control.readVector3f( in ) );
        ((OrientedShape3D)node).setRotationPoint( control.readPoint3f( in ) );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new OrientedShape3D();
    }

        
}
