/*
 *  @(#)PathInterpolatorState.java 1.3 00/12/19 17:17:09
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.PathInterpolator;
import javax.media.j3d.SceneGraphObject;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.3, 12/19/00
 */
public abstract class PathInterpolatorState extends InterpolatorState {

    protected float[] knots;
    
    public PathInterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
    }
    
    public void writeConstructorParams( DataOutput out ) throws IOException {
        super.writeConstructorParams( out );
        knots = new float[ ((PathInterpolator)node).getArrayLengths() ];
        out.writeInt( knots.length );
        ((PathInterpolator)node).getKnots( knots );
        for(int i=0; i<knots.length; i++)
            out.writeFloat( knots[i] );
    }
    
    public void readConstructorParams( DataInput in ) throws IOException {
        super.readConstructorParams( in );
        knots = new float[ in.readInt() ];
        for(int i=0; i<knots.length; i++)
            knots[i] = in.readFloat();
    }

}
