/*
 *  @(#)PointAttributesState.java 1.4 01/03/02 15:34:20
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.PointAttributes;

public class PointAttributesState extends NodeComponentState {
    
    public PointAttributesState( SymbolTableData symbol, Controller control ) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        PointAttributes attr = (PointAttributes)node;
        out.writeBoolean( attr.getPointAntialiasingEnable() );
        out.writeFloat( attr.getPointSize() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        PointAttributes attr = (PointAttributes)node;
        attr.setPointAntialiasingEnable( in.readBoolean() );
        attr.setPointSize( in.readFloat() );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new PointAttributes();
    }

    
}

