/*
 *  @(#)PointLightState.java 1.4 01/03/02 15:34:20
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.*;
import javax.media.j3d.PointLight;
import javax.vecmath.Point3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.4, 03/02/01
 */
public class PointLightState extends LightState {

    public PointLightState( SymbolTableData symbol, Controller control ) {
	super( symbol, control );

    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
	Point3f point = new Point3f();
	((PointLight)node).getAttenuation( point );
	control.writePoint3f( out, point );
	((PointLight)node).getPosition( point );
	control.writePoint3f( out, point );
    }

    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
	((PointLight)node).setAttenuation( control.readPoint3f(in) );
	((PointLight)node).setPosition( control.readPoint3f(in) );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new PointLight();
    }

}
