/*
 *  @(#)PointSoundState.java 1.3 01/03/02 15:34:39
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.PointSound;
import javax.media.j3d.SceneGraphObject;
import javax.vecmath.Point3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.3 03/02/01
 */
public class PointSoundState extends SoundState {

    public PointSoundState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        float[] distance = new float[ ((PointSound)node).getDistanceGainLength() ];
        float[] gain = new float[ distance.length ];
        
        ((PointSound)node).getDistanceGain( distance, gain );
        out.writeInt( distance.length );
        for(int i=0; i<distance.length; i++) {
            out.writeFloat( distance[i] );
            out.writeFloat( gain[i] );
        }
        
        Point3f pos = new Point3f();
        
        ((PointSound)node).getPosition( pos );
        control.writePoint3f( out, pos );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
                    
        float[] distance = new float[ in.readInt() ];
        float[] gain = new float[ distance.length ];
        for(int i=0; i<distance.length; i++) {
            distance[i] = in.readFloat();
            gain[i] = in.readFloat();
        }
        ((PointSound)node).setDistanceGain( distance, gain );
        
        ((PointSound)node).setPosition( control.readPoint3f( in ));
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new PointSound();
    }

    
}
