/*
 *  @(#)PolygonAttributesState.java 1.4 01/03/02 15:34:22
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.PolygonAttributes;

public class PolygonAttributesState extends NodeComponentState {
    
    public PolygonAttributesState( SymbolTableData symbol, Controller control ) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        PolygonAttributes polyAttr = (PolygonAttributes)node;
        out.writeBoolean( polyAttr.getBackFaceNormalFlip() );
        out.writeInt( polyAttr.getCullFace() );
        out.writeInt( polyAttr.getPolygonMode() );
        out.writeFloat( polyAttr.getPolygonOffset() );
        out.writeFloat( polyAttr.getPolygonOffsetFactor() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        PolygonAttributes polyAttr = (PolygonAttributes)node;
        polyAttr.setBackFaceNormalFlip( in.readBoolean() );
        polyAttr.setCullFace( in.readInt() );
        polyAttr.setPolygonMode( in.readInt() );
        polyAttr.setPolygonOffset( in.readFloat() );
        polyAttr.setPolygonOffsetFactor( in.readFloat() );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new PolygonAttributes();
    }

    
}

