/*
 *  @(#)PositionInterpolatorState.java 1.4 01/03/02 15:34:40
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.PositionInterpolator;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Point3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.4 03/02/01
 */
public class PositionInterpolatorState extends InterpolatorState {

    private int target;
    private Transform3D axisOfTranslation;
    private float startPosition;
    private float endPosition;
    
    public PositionInterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null)
            target = control.getSymbolTable().addReference( ((PositionInterpolator)node).getTarget() );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( target );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
                        
        target = in.readInt();
    }
    
    public void writeConstructorParams( DataOutput out ) throws IOException {
        super.writeConstructorParams( out );
        
        control.writeTransform3D( out, ((PositionInterpolator)node).getAxisOfTranslation() );
                
        out.writeFloat( ((PositionInterpolator)node).getStartPosition() );
        out.writeFloat( ((PositionInterpolator)node).getEndPosition() );
    }
    
    public void readConstructorParams( DataInput in ) throws IOException {
        super.readConstructorParams( in );
        
        axisOfTranslation =  control.readTransform3D( in );
        startPosition = in.readFloat();
        endPosition = in.readFloat();

    }

    
    public void buildGraph() {
        super.buildGraph();
        
        ((PositionInterpolator)node).setTarget( (TransformGroup)control.getSymbolTable().getJ3dNode( target ));
    }
    
    public SceneGraphObject createNode( Class j3dClass ) {
        return createNode( j3dClass, new Class[] { javax.media.j3d.Alpha.class,
                                                    TransformGroup.class,
                                                    Transform3D.class,
                                                    Float.TYPE,
                                                    Float.TYPE },
                                      new Object[] { null,
                                                     null,
                                                     axisOfTranslation,
                                                     new Float(startPosition),
                                                     new Float(endPosition) } );
                                                    
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new PositionInterpolator( null, null, axisOfTranslation, startPosition, endPosition );
    }


}
