/*
 *  @(#)PositionPathInterpolatorState.java 1.6 01/03/02 15:34:34
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.PositionPathInterpolator;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Point3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.6, 03/02/01
 */
public class PositionPathInterpolatorState extends PathInterpolatorState {

    private int target;
    private Point3f[] positions;
    private Transform3D axisOfTranslation;
    
    public PositionPathInterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null)
            target = control.getSymbolTable().addReference( ((PositionPathInterpolator)node).getTarget() );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( target );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
                
        target = in.readInt();
    }
    
    public void writeConstructorParams( DataOutput out ) throws IOException {
        super.writeConstructorParams( out );
        
        control.writeTransform3D( out, ((PositionPathInterpolator)node).getAxisOfTranslation() );
                
        positions = new Point3f[ knots.length ];
        for(int i=0; i<positions.length; i++)
            positions[i] = new Point3f();

        ((PositionPathInterpolator)node).getPositions( positions );
        for(int i=0; i<positions.length; i++)
            control.writePoint3f( out, positions[i] );
    }
    
    public void readConstructorParams( DataInput in ) throws IOException {
        super.readConstructorParams( in );
        
        axisOfTranslation =  control.readTransform3D( in );

        positions = new Point3f[ knots.length ];
        for(int i=0; i<positions.length; i++)
            positions[i] = control.readPoint3f( in );
        
    }

    
    public void buildGraph() {
        super.buildGraph();
        
        ((PositionPathInterpolator)node).setTarget( (TransformGroup)control.getSymbolTable().getJ3dNode( target ));
    }
    
    public SceneGraphObject createNode( Class j3dClass ) {
        return createNode( j3dClass, new Class[] { javax.media.j3d.Alpha.class,
                                                    TransformGroup.class,
                                                    Transform3D.class,
                                                    knots.getClass(),
                                                    positions.getClass() },
                                      new Object[] { null,
                                                     null,
                                                     axisOfTranslation,
                                                     knots,
                                                     positions } );
                                                    
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new PositionPathInterpolator( null, null, axisOfTranslation, knots, positions );
    }


}
