/*
 *  @(#)RenderingAttributesState.java 1.4 01/03/02 15:34:23
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.RenderingAttributes;

public class RenderingAttributesState extends NodeComponentState {
    
    public RenderingAttributesState( SymbolTableData symbol, Controller control ) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        RenderingAttributes attr = (RenderingAttributes)node;
        out.writeInt( attr.getAlphaTestFunction() );
        out.writeFloat( attr.getAlphaTestValue() );
        out.writeBoolean( attr.getDepthBufferEnable() );
        out.writeBoolean( attr.getDepthBufferWriteEnable() );
        out.writeBoolean( attr.getIgnoreVertexColors() );
        out.writeInt( attr.getRasterOp() );
        out.writeBoolean( attr.getRasterOpEnable() );
        out.writeBoolean( attr.getVisible() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        RenderingAttributes attr = (RenderingAttributes)node;
        attr.setAlphaTestFunction( in.readInt() );
        attr.setAlphaTestValue( in.readFloat() );
        attr.setDepthBufferEnable( in.readBoolean() );
        attr.setDepthBufferWriteEnable( in.readBoolean() );
        attr.setIgnoreVertexColors( in.readBoolean() );
        attr.setRasterOp( in.readInt() );
        attr.setRasterOpEnable( in.readBoolean() );
        attr.setVisible( in.readBoolean() );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new RenderingAttributes();
    }

    
}

