/*
 *  @(#)RotationInterpolatorState.java 1.5 01/03/02 15:34:24
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.RotationInterpolator;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.Alpha;
import javax.vecmath.Matrix4d;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.5, 03/02/01
 */
public class RotationInterpolatorState extends InterpolatorState {

    private int target;
    
    public RotationInterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        RotationInterpolator interp = (RotationInterpolator)node;
        
        Transform3D trans = interp.getAxisOfRotation();
        Matrix4d mat = new Matrix4d();
        trans.get( mat );
        
        control.writeMatrix4d( out, mat );
        out.writeFloat( interp.getMaximumAngle() );
        out.writeFloat( interp.getMinimumAngle() );
        out.writeInt( control.getSymbolTable().addReference( interp.getTarget() ));
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        RotationInterpolator interp = (RotationInterpolator)node;
        
        interp.setAxisOfRotation( new Transform3D( control.readMatrix4d( in )));
        interp.setMaximumAngle( in.readFloat() );
        interp.setMinimumAngle( in.readFloat() );
        target = in.readInt();

    }
    
    public void buildGraph() {
        super.buildGraph();
        ((RotationInterpolator)node).setTarget( (TransformGroup)control.getSymbolTable().getJ3dNode( target ));
    }

    public SceneGraphObject createNode( Class j3dClass ) {
        return createNode( j3dClass, new Class[] { Alpha.class, TransformGroup.class },
        new Object[] { null, null } );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new RotationInterpolator( null, null);
    }

}
