/*
 *  @(#)RotationPathInterpolatorState.java 1.5 01/03/02 15:34:37
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.RotationPathInterpolator;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Quat4f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.5, 03/02/01
 */
public class RotationPathInterpolatorState extends PathInterpolatorState {

    private int target;
    private Quat4f[] quats;
    private Transform3D axisOfTranslation;
    
    public RotationPathInterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null)
            target = control.getSymbolTable().addReference( ((RotationPathInterpolator)node).getTarget() );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( target );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
                
        target = in.readInt();
    }
    
    public void writeConstructorParams( DataOutput out ) throws IOException {
        super.writeConstructorParams( out );
        
        control.writeTransform3D( out, ((RotationPathInterpolator)node).getAxisOfRotation() );
                
        quats = new Quat4f[ knots.length ];
        for(int i=0; i<quats.length; i++) {
            quats[i] = new Quat4f();
        }

        ((RotationPathInterpolator)node).getQuats( quats );
        for(int i=0; i<quats.length; i++) {
            control.writeQuat4f( out, quats[i] );
        }
    }
    
    public void readConstructorParams( DataInput in ) throws IOException {
        super.readConstructorParams( in );
        
        axisOfTranslation =  control.readTransform3D( in );

        quats = new Quat4f[ knots.length ];
        for(int i=0; i<quats.length; i++) {
            quats[i] = control.readQuat4f( in );
        }
        
    }

    
    public void buildGraph() {
        super.buildGraph();
        
        ((RotationPathInterpolator)node).setTarget( (TransformGroup)control.getSymbolTable().getJ3dNode( target ));
    }
    
    public SceneGraphObject createNode( Class j3dClass ) {
        return createNode( j3dClass, new Class[] { javax.media.j3d.Alpha.class,
                                                    TransformGroup.class,
                                                    Transform3D.class,
                                                    knots.getClass(),
                                                    quats.getClass() },
                                      new Object[] { null,
                                                     null,
                                                     axisOfTranslation,
                                                     knots,
                                                     quats } );
                                                    
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new RotationPathInterpolator( null, null, axisOfTranslation, knots, quats );
    }


}
