/*
 *  @(#)ScaleInterpolatorState.java 1.4 01/03/02 15:34:41
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.ScaleInterpolator;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Point3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.4, 03/02/01
 */
public class ScaleInterpolatorState extends PathInterpolatorState {

    private int target;
    private Point3f[] positions;
    private Transform3D axisOfTranslation;
    
    public ScaleInterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null)
            target = control.getSymbolTable().addReference( ((ScaleInterpolator)node).getTarget() );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( target );
        control.writeTransform3D( out, ((ScaleInterpolator)node).getAxisOfScale() );
        out.writeFloat( ((ScaleInterpolator)node).getMinimumScale() );
        out.writeFloat( ((ScaleInterpolator)node).getMaximumScale() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
                
        target = in.readInt();
        ((ScaleInterpolator)node).setAxisOfScale( control.readTransform3D( in ) );
        ((ScaleInterpolator)node).setMinimumScale( in.readFloat() );
        ((ScaleInterpolator)node).setMaximumScale( in.readFloat() );
    }
    
    
    public void buildGraph() {
        super.buildGraph();
        
        ((ScaleInterpolator)node).setTarget( (TransformGroup)control.getSymbolTable().getJ3dNode( target ));
    }
    
    public SceneGraphObject createNode( Class j3dClass ) {
        return createNode( j3dClass, new Class[] { javax.media.j3d.Alpha.class,
                                                    TransformGroup.class },
                                      new Object[] { null,
                                                     null } );
                                                    
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new ScaleInterpolator( null, null );
    }


}
