/*
 *  @(#)SoundState.java 1.2 00/12/19 17:17:24
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.Sound;
import javax.media.j3d.MediaContainer;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.BoundingLeaf;
import javax.media.j3d.SceneGraphObject;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.2 12/19/00
 */
public abstract class SoundState extends LeafState {

    private int boundingLeaf;
    private int mediaContainer;
    
    public SoundState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null) {
            boundingLeaf = control.getSymbolTable().addReference( ((Sound)node).getSchedulingBoundingLeaf() );
            mediaContainer = control.getSymbolTable().addReference( ((Sound)node).getSoundData() );
        }
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        Sound sound = (Sound)node;
        
        out.writeBoolean( sound.getContinuousEnable() );
        out.writeBoolean( sound.getEnable() );
        out.writeFloat( sound.getInitialGain() );
        out.writeInt( sound.getLoop() );
        out.writeFloat( sound.getPriority() );
        out.writeBoolean( sound.getReleaseEnable() );
        out.writeInt( boundingLeaf );
        control.writeBounds( out, sound.getSchedulingBounds() );
        out.writeInt( mediaContainer );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
                        
        Sound sound = (Sound)node;
        
        sound.setContinuousEnable( in.readBoolean() );
        sound.setEnable( in.readBoolean() );
        sound.setInitialGain( in.readFloat() );
        sound.setLoop( in.readInt() );
        sound.setPriority( in.readFloat() );
        sound.setReleaseEnable( in.readBoolean() );
        boundingLeaf = in.readInt();
        sound.setSchedulingBounds( control.readBounds( in ));
        mediaContainer = in.readInt();
    }
    
    
    public void buildGraph() {
        super.buildGraph();
        
        ((Sound)node).setSchedulingBoundingLeaf( (BoundingLeaf)control.getSymbolTable().getJ3dNode( boundingLeaf ));
        ((Sound)node).setSoundData( (MediaContainer)control.getSymbolTable().getJ3dNode( mediaContainer ));
    }
    

}
