/*
 *  @(#)SoundscapeState.java 1.3 01/03/02 15:34:38
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.Soundscape;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.BoundingLeaf;
import javax.media.j3d.AuralAttributes;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.3 03/02/01
 */
public class SoundscapeState extends LeafState {

    private int boundingLeaf;
    private int auralAttributes;
    
    public SoundscapeState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( control.getSymbolTable().addReference( ((Soundscape)node).getApplicationBoundingLeaf() ));
        control.writeBounds( out, ((Soundscape)node).getApplicationBounds() );
        out.writeInt( control.getSymbolTable().addReference( ((Soundscape)node).getAuralAttributes() ));
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
        boundingLeaf = in.readInt();
        ((Soundscape)node).setApplicationBounds( control.readBounds(in));
        auralAttributes = in.readInt();
    }
    
    public void buildGraph() {
        ((Soundscape)node).setApplicationBoundingLeaf( (BoundingLeaf)control.getSymbolTable().getJ3dNode( boundingLeaf ));
        ((Soundscape)node).setAuralAttributes( (AuralAttributes)control.getSymbolTable().getJ3dNode( auralAttributes ));
        
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new Soundscape();
    }

    
}
