/*
 *  @(#)SwitchValueInterpolatorState.java 1.4 01/03/02 15:34:39
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.SwitchValueInterpolator;
import javax.media.j3d.Switch;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Point3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.4 03/02/01
 */
public class SwitchValueInterpolatorState extends InterpolatorState {

    private int target;
    
    public SwitchValueInterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null)
            target = control.getSymbolTable().addReference( ((SwitchValueInterpolator)node).getTarget() );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( target );
        out.writeInt( ((SwitchValueInterpolator)node).getFirstChildIndex() );
        out.writeInt( ((SwitchValueInterpolator)node).getLastChildIndex() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
                        
        target = in.readInt();
        ((SwitchValueInterpolator)node).setFirstChildIndex( in.readInt() );
        ((SwitchValueInterpolator)node).setLastChildIndex( in.readInt() );
    }
    
    
    public void buildGraph() {
        super.buildGraph();
        
        ((SwitchValueInterpolator)node).setTarget( (Switch)control.getSymbolTable().getJ3dNode( target ));
    }
    
    public SceneGraphObject createNode( Class j3dClass ) {
        return createNode( j3dClass, new Class[] { javax.media.j3d.Alpha.class,
                                                    javax.media.j3d.Switch.class },
                                      new Object[] { null,
                                                     null } );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new SwitchValueInterpolator( null, null );
    }


}
