/*
 *  @(#)TexCoordGenerationState.java 1.4 01/03/02 15:34:27
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.TexCoordGeneration;
import javax.vecmath.Vector4f;

public class TexCoordGenerationState extends NodeComponentState {
    
    public TexCoordGenerationState( SymbolTableData symbol, Controller control ) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        TexCoordGeneration attr = (TexCoordGeneration)node;
        Vector4f vec = new Vector4f();
        out.writeBoolean( attr.getEnable() );
        out.writeInt( attr.getFormat() );
        out.writeInt( attr.getGenMode() );
        attr.getPlaneR( vec );
        control.writeVector4f( out, vec );
        attr.getPlaneS( vec );
        control.writeVector4f( out, vec );
        attr.getPlaneT( vec );
        control.writeVector4f( out, vec );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        TexCoordGeneration attr = (TexCoordGeneration)node;
        attr.setEnable( in.readBoolean() );
        attr.setFormat( in.readInt() );
        attr.setGenMode( in.readInt() );
        attr.setPlaneR( control.readVector4f( in ));
        attr.setPlaneS( control.readVector4f( in ));
        attr.setPlaneT( control.readVector4f( in ));
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new TexCoordGeneration();
    }

    
}

