/*
 *  @(#)Text3DState.java 1.3 01/03/02 15:34:45
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.Text3D;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Font3D;
import javax.media.j3d.BoundingBox;
import javax.vecmath.Point3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import com.sun.j3d.demos.utils.scenegraph.io.retained.NcFont3D;

/**
 * @author Paul Byrne
 * @version 1.3 03/02/01
 */
public class Text3DState extends GeometryState {
    
    private int font3d;
    private String string;
    
    public Text3DState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null) {
            NcFont3D font3D = NcFont3D.getNcFont3D( ((Text3D)node).getFont3D() );
            font3d = control.getSymbolTable().addReference( font3D );
        }
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( ((Text3D)node).getAlignment() );
        out.writeFloat( ((Text3D)node).getCharacterSpacing() );
        out.writeInt( font3d );
        
        out.writeInt( ((Text3D)node).getPath() );
        
        Point3f pos = new Point3f();
        ((Text3D)node).getPosition( pos );
        control.writePoint3f( out, pos );
        
        out.writeUTF( ((Text3D)node).getString() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
        ((Text3D)node).setAlignment( in.readInt() );
        ((Text3D)node).setCharacterSpacing( in.readFloat() );
        font3d = in.readInt();
        ((Text3D)node).setPath( in.readInt() );
        ((Text3D)node).setPosition( control.readPoint3f(in ));
        string = in.readUTF();
    }
    
    public void buildGraph() {
        ((Text3D)node).setFont3D( ((NcFont3D)control.getSymbolTable().getJ3dNode( font3d )).getFont3D() );
        ((Text3D)node).setString( string );
        
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new Text3D();
    }

}
