/*
 *  @(#)Texture3DState.java 1.6 01/03/02 15:34:28
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Texture3D;

public class Texture3DState extends TextureState {
    
    private int depth;
    
    public Texture3DState( SymbolTableData symbol, Controller control ) {
        super(symbol, control);
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        out.writeInt( ((Texture3D)node).getBoundaryModeR() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        ((Texture3D)node).setBoundaryModeR( in.readInt() );
    }
    
    public void writeConstructorParams( DataOutput out ) throws IOException {
        super.writeConstructorParams( out );
        out.writeInt( ((Texture3D)node).getDepth() );
    }
    
    public void readConstructorParams( DataInput in ) throws IOException {
        super.readConstructorParams( in );
        depth = in.readInt();
    }
    
    public SceneGraphObject createNode( Class j3dClass ) {
        return createNode( j3dClass, new Class[] { Integer.TYPE,
                                                    Integer.TYPE,
                                                    Integer.TYPE,
                                                    Integer.TYPE,
                                                    Integer.TYPE },
                                      new Object[] { new Integer( mipMapMode ),
                                                     new Integer( format ),
                                                     new Integer( width ),
                                                     new Integer( height ),
                                                     new Integer( depth ) } );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new Texture3D( mipMapMode, format, width, height, depth );
    }

    
}
