/*
 *  @(#)TransformGroupState.java 1.4 01/03/02 15:34:31
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.Transform3D;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.4, 03/02/01
 */
public class TransformGroupState extends GroupState {

    /** Creates new BranchGroupState */
    public TransformGroupState( SymbolTableData symbol, Controller control ) {
        super( symbol, control );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        Transform3D trans = new Transform3D();
        ((TransformGroup)node).getTransform( trans );
        double[] matrix = new double[16];
        trans.get( matrix );
        
        for(int i=0; i<16; i++)
            out.writeDouble( matrix[i] );
        
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        Transform3D trans = new Transform3D();
        double[] matrix = new double[16];
        
        for(int i=0; i<16; i++)
            matrix[i] = in.readDouble();
        
        trans.set( matrix );
        ((TransformGroup)node).setTransform( trans );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new TransformGroup();
    }


}
