/*
 *  @(#)TransparencyInterpolatorState.java 1.4 01/03/02 15:34:40
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.TransparencyInterpolator;
import javax.media.j3d.TransparencyAttributes;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Point3f;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version 1.4 03/02/01
 */
public class TransparencyInterpolatorState extends InterpolatorState {

    private int target;
    
    public TransparencyInterpolatorState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
        
        if (node!=null)
            target = control.getSymbolTable().addReference( ((TransparencyInterpolator)node).getTarget() );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeInt( target );
        out.writeFloat( ((TransparencyInterpolator)node).getMinimumTransparency() );
        out.writeFloat( ((TransparencyInterpolator)node).getMaximumTransparency() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
                        
        target = in.readInt();
        ((TransparencyInterpolator)node).setMinimumTransparency( in.readFloat() );
        ((TransparencyInterpolator)node).setMaximumTransparency( in.readFloat() );
    }
    
    
    public void buildGraph() {
        super.buildGraph();
        
        ((TransparencyInterpolator)node).setTarget( (TransparencyAttributes)control.getSymbolTable().getJ3dNode( target ));
    }
    
    public SceneGraphObject createNode( Class j3dClass ) {
        return createNode( j3dClass, new Class[] { javax.media.j3d.Alpha.class,
                                                    javax.media.j3d.TransparencyAttributes.class },
                                      new Object[] { null,
                                                     null } );
    }
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new TransparencyInterpolator( null, null );
    }


}
