/*
 *  @(#)ViewPlatformState.java 1.3 01/03/02 15:34:35
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.io.state.javax.media.j3d;

import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import javax.media.j3d.ViewPlatform;
import javax.media.j3d.SceneGraphObject;
import com.sun.j3d.demos.utils.scenegraph.io.retained.Controller;
import com.sun.j3d.demos.utils.scenegraph.io.retained.SymbolTableData;

/**
 * @author Paul Byrne
 * @version	1.3, 03/02/01
 */
public class ViewPlatformState extends LeafState {

    private int[] geometry;
    private int appearance;
    
    public ViewPlatformState(SymbolTableData symbol,Controller control) {
        super( symbol, control );
    }
    
    public void writeObject( DataOutput out ) throws IOException {
        super.writeObject( out );
        
        out.writeFloat( ((ViewPlatform)node).getActivationRadius() );
        out.writeInt( ((ViewPlatform)node).getViewAttachPolicy() );
    }
    
    public void readObject( DataInput in ) throws IOException {
        super.readObject( in );
        
        ((ViewPlatform)node).setActivationRadius( in.readFloat() );
        ((ViewPlatform)node).setViewAttachPolicy( in.readInt() );
    }
    
    
    protected javax.media.j3d.SceneGraphObject createNode() {
        return new ViewPlatform();
    }

}
