/*
 *  @(#)AppearanceChangeProcessor.java 1.2 00/12/19 17:24:39
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.traverser;

import javax.media.j3d.Shape3D;
import javax.media.j3d.Appearance;

/** 
 * Abstract class for changing the parameters of Appearance Node Components.
 * Subclasses implement changeAppearance to make the actual updates
 *
 * @author  paulby
 * @version 
 */
abstract class AppearanceChangeProcessor implements ProcessNodeInterface {

  /**
    * Called by TreeScan. node must be an instance of Shape3D
    */
  public void processNode(javax.media.j3d.Node node) {
    Appearance app = ((Shape3D)node).getAppearance();
    changeAppearance( (Shape3D)node, app );
  }
  
  public abstract void changeAppearance( javax.media.j3d.Shape3D shape,
                                          javax.media.j3d.Appearance app );
}
