/*
 *  @(#)BehaviorSetEnable.java 1.2 00/12/19 17:24:40
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.traverser;

import javax.media.j3d.PolygonAttributes;
import javax.media.j3d.Appearance;

/**
 * Set the enable flag on behaviors in the tree
 *
 * @author Paul Byrne
 * @version	1.2, 12/19/00
 */
public class BehaviorSetEnable extends Object {

  /**
    * Traverse the graph setting the polygon mode in all PolygonAttributes.
    * If createAttribute is false on PolygonAttribute objects that already
    * exist are modified.
    * If craeteAttribute is true, PolygonAttributes and Appearance objects will
    * be created as necessary
    */
  public static void setBehaviorEnable( javax.media.j3d.Node treeRoot,
                                     final boolean enable ) {
  
    NodeChangeProcessor processor = new NodeChangeProcessor() {
      public void changeNode( javax.media.j3d.Node node ) {
          ((javax.media.j3d.Behavior)node).setEnable( enable );
      }
    };
    
    try {
      Class behaviorClass = Class.forName("javax.media.j3d.Behavior");
    
      TreeScan.findNode( treeRoot, behaviorClass, processor, true, true );
    } catch(Exception e ) {
      e.printStackTrace();
      System.out.println( "ERROR BehaviorSetEnable, SceneGraph contains"+
                          " Live or compiled nodes, without correct capabilities");
    }
  }
  
}
