/*
 *  @(#)ChangeMaterial.java 1.2 00/12/19 17:24:41
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.traverser;

import javax.media.j3d.Material;

/** 
 * Make changes to the Material properties for ALL Materials in the
 * scene graph provided
 *
 * @author  paulby
 * @version 1.2, 12/19/00
 */
public class ChangeMaterial extends Object {

  /**
    * Set the LightingEnable state in every Material in the SceneGraph
    * treeRoot
    * @param treeRoot, root of Scene Graph
    * @param state, Lighting state
    */
  public static void setLightingEnable( javax.media.j3d.Node treeRoot,
                                     final boolean state ) {
  
    AppearanceChangeProcessor processor = new AppearanceChangeProcessor() {
      public void changeAppearance( javax.media.j3d.Shape3D shape,
                                    javax.media.j3d.Appearance app ) {
        if (app==null) return;
        Material mat = app.getMaterial();
        if (mat!=null)
          mat.setLightingEnable( state );
      }
    };
    
    scanTree( treeRoot, processor );
  }
    
  private static void scanTree( javax.media.j3d.Node treeRoot, 
                                AppearanceChangeProcessor processor ) {
    try {
      Class shapeClass = Class.forName("javax.media.j3d.Shape3D");
    
      TreeScan.findNode( treeRoot, shapeClass, processor, false, true );
    } catch(Exception e ) {
      System.out.println( "ERROR ChangeMaterial, SceneGraph contains Live or compiled nodes");
    }
  }
  
}
