/*
 *  @(#)ChangeTextureAttributes.java 1.2 00/12/19 17:24:43
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.scenegraph.traverser;

import javax.media.j3d.Texture;
import javax.media.j3d.Appearance;

/** 
 *
 * @author  paulby
 * @version 
 */
public class ChangeTextureAttributes extends Object {

  /**
    * Traverse the graph setting the Texture Enable flag in all Texture
    * objects that exist
    */
  public static void setTextureEnable( javax.media.j3d.Node treeRoot,
                                     final boolean enabled ) {

   AppearanceChangeProcessor processor = new AppearanceChangeProcessor() {
      public void changeAppearance( javax.media.j3d.Shape3D shape,
                                    javax.media.j3d.Appearance app ) {
        if (app==null) return;
        Texture texture = app.getTexture();
        if (texture!=null)
          texture.setEnable( enabled );
      }
    };
    
    scanTree( treeRoot, processor );
  }
  
  private static void scanTree( javax.media.j3d.Node treeRoot, 
                                AppearanceChangeProcessor processor ) {
    try {
      Class shapeClass = Class.forName("javax.media.j3d.Shape3D");
    
      TreeScan.findNode( treeRoot, shapeClass, processor, false, true );
    } catch(Exception e ) {
      e.printStackTrace();
      System.out.println( "ERROR ChangeTextureAttributes, SceneGraph contains"+
                          " Live or compiled nodes, without correct capabilities");
    }
  }
  
}
