/*
 *  @(#)FlyControlDialog.java 1.3 00/12/19 17:29:40
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.vpbehaviors;

import com.sun.j3d.demos.utils.gui.FloatDocument;

/**
 *
 * @author  Paul Byrne
 * @version 1.3 12/19/00
 */
public class FlyControlDialog extends javax.swing.JDialog {

    private boolean userCancel = true;     // Did user cancel dialog ?
    
    /** Creates new form FlyControlDialog */
    public FlyControlDialog(java.awt.Frame parent,boolean modal) {
        super (parent, modal);
        initComponents ();
        pack ();
        
        int x = parent.getWidth()/2 - this.getWidth()/2;
        int y = parent.getHeight()/2 - this.getHeight()/2;
        
        setLocation( x, y );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        stepTF = new javax.swing.JTextField();
        angleTF = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        okB = new javax.swing.JButton();
        cancelB = new javax.swing.JButton();
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jLabel1.setText("Step size");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 4);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
          jPanel1.add(jLabel1, gridBagConstraints1);
          
          
        jLabel2.setText("Angle Size");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 0;
          gridBagConstraints1.gridy = 1;
          gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 4);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
          jPanel1.add(jLabel2, gridBagConstraints1);
          
          
        stepTF.setPreferredSize(new java.awt.Dimension(60, 21));
          stepTF.setToolTipText("The maximum distance view will move per frame when mouse pointer is at the window limit");
          stepTF.setText("jTextField1");
          stepTF.setMinimumSize(new java.awt.Dimension(60, 21));
          stepTF.setDocument(new FloatDocument());
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          jPanel1.add(stepTF, gridBagConstraints1);
          
          
        angleTF.setPreferredSize(new java.awt.Dimension(60, 21));
          angleTF.setToolTipText("The maximum rotation angle the view will move per frame");
          angleTF.setText("jTextField2");
          angleTF.setMinimumSize(new java.awt.Dimension(60, 21));
          angleTF.setDocument(new FloatDocument());
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 1;
          gridBagConstraints1.gridy = 1;
          jPanel1.add(angleTF, gridBagConstraints1);
          
          
        jLabel3.setText("m.");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.insets = new java.awt.Insets(0, 4, 0, 0);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          jPanel1.add(jLabel3, gridBagConstraints1);
          
          
        jLabel4.setText("deg.");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 2;
          gridBagConstraints1.gridy = 1;
          gridBagConstraints1.insets = new java.awt.Insets(0, 4, 0, 0);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          jPanel1.add(jLabel4, gridBagConstraints1);
          
          
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
        
        
        
        okB.setText("OK");
          okB.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  okBActionPerformed(evt);
              }
          }
          );
          jPanel2.add(okB);
          
          
        cancelB.setText("Cancel");
          cancelB.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  cancelBActionPerformed(evt);
              }
          }
          );
          jPanel2.add(cancelB);
          
          
        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);
        
    }//GEN-END:initComponents

  private void cancelBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBActionPerformed
// Add your handling code here:
      setVisible( false );
      userCancel = true;
  }//GEN-LAST:event_cancelBActionPerformed

  private void okBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okBActionPerformed
// Add your handling code here:
      setVisible( false );
      userCancel = false;
  }//GEN-LAST:event_okBActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
        userCancel = true;
    }//GEN-LAST:event_closeDialog

    /**
     * User cancelled dialog
     *
     * @return false if the OK button was pressed, false otherwise
     */
    public boolean userCancelled() {
        return userCancel;
    }
    
    /**
     * Returns the angle from the dialog
     */
    public float getAngle() {
        try {
            return Float.parseFloat( angleTF.getText() );
        } catch( NumberFormatException e ) {
            e.printStackTrace();
            return 3f;
        }
    }
    
    public void setAngle( float angle ) {
        angleTF.setText( Float.toString( angle ));
    }
    
    
    /**
     * Returns the step from the dialog
     */
    public float getStep() {
        try {
            return Float.parseFloat( stepTF.getText() );
        } catch( NumberFormatException e ) {
            e.printStackTrace();
            return 10f;
        }
    }
    
    public void setStep( float step ) {
        stepTF.setText( Float.toString( step ));
    }
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField stepTF;
    private javax.swing.JTextField angleTF;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton okB;
    private javax.swing.JButton cancelB;
    // End of variables declaration//GEN-END:variables

}
