/*
 *  @(#)RayCollision.java 1.2 00/12/19 17:29:43
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.vpbehaviors;

import javax.media.j3d.Shape3D;
import javax.media.j3d.Geometry;
import javax.vecmath.Point3d;

/**
 * Provides information on the collision of a ray with geometry
 * in the scene. The amount of information set in an object of
 * this class will depend on the mode set in VPDefaultCollision.
 *
 * @author Paul Byrne
 * @version	1.2, 12/19/00
 */
public class RayCollision extends java.lang.Object {

    public static int FRONT = 0;
    public static int BACK = 1;
    public static int LEFT = 2;
    public static int RIGHT = 3;
    public static int UP = 4;
    public static int DOWN = 5;
    
    public int rayIndex;
    public int rayDirection;       // FRONT, BACK, LEFT, RIGHT, UP, DOWN
    public Shape3D collisionShape=null;
    public Geometry collisionGeometryArray=null;
    public Point3d collisionPoint=null;        // In VW coordinates
    
}
