/*
 *  @(#)SimpleSweptVolume.java 1.3 00/12/19 17:29:46
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.vpbehaviors;

import javax.vecmath.Vector3f;

/**
 * The simplest Collision Swept Volume consisting of a single ray cast
 * from the eye in each direction
 *
 * @author Paul Byrne
 * @version	1.3, 12/19/00
 */
public class SimpleSweptVolume extends SweptVolume {

    /** Creates new SimpleSweptVolume */
    public SimpleSweptVolume() {
        frontRays = new Vector3f[] { new Vector3f(0f, 0f, 0f), new Vector3f( 0f, 0f, -1f ) };
        backRays = new Vector3f[] { new Vector3f(0f, 0f, 0f), new Vector3f( 0f, 0f, 1f ) };
        leftRays = new Vector3f[] { new Vector3f(0f, 0f, 0f), new Vector3f( -1f, 0f, 0f ) };
        rightRays = new Vector3f[] { new Vector3f(0f, 0f, 0f), new Vector3f( 1f, 0f, 0f ) };
        upRays = new Vector3f[] { new Vector3f(0f, 0f, 0f), new Vector3f( 0f, 1f, 0f ) };
        downRays = new Vector3f[] { new Vector3f(0f, 0f, 0f), new Vector3f( 0f, -1f, 0f ) };
    }

}
