/*
 *  @(#)VPBehavior.java 1.7 01/01/09 10:40:12
 *
 * Copyright (c) 2000-2001 Sun Microsystems, Inc. All Rights Reserved.
 */
package com.sun.j3d.demos.utils.vpbehaviors;

import javax.media.j3d.TransformGroup;
import javax.media.j3d.View;

public abstract class VPBehavior extends com.sun.j3d.utils.behaviors.vp.ViewPlatformBehavior {

    protected VPCollisionInterface collisionControl;
    protected TransformGroup targetTG;
    protected View view;
    private boolean collisionEnabled=false;
    
    public VPBehavior( View view ) {
        this.view = view;
    }
    
    /**
      * @deprecated Use VPBehavior( View view )
      */
    public VPBehavior() {
    }

    /**
      * Set the collision control object, can be null
      *
      * Called when behavior is set using VPBehaviorControl.setVPBehavior or
      * when collision control is changed using
      * VPBehaviorControl.setVPCollisionControl
      */
    public void setCollisionControl( VPCollisionInterface collisionControl ) {
        this.collisionControl = collisionControl;
        if (collisionControl!=null)
            collisionEnabled = true;
        else
            collisionEnabled = false;
    }

    /**
      * Set the TransformGroup on which this behavior acts
      * This is called when the behavior is set using
      * VPBehaviorControl.setVPBehavior
      */
    public void setTarget( TransformGroup targetTG ) {
        this.targetTG = targetTG;
    }
    
    /**
     * Returns the TransformGroup this behavior acts on
     */
    public TransformGroup getTarget() {
        return targetTG;
    }
    
    /**
     * Called when the user wants to change the parameters of the
     * behavior.
     * 
     * This method may be called for the AWT event thread
     *
     * @param parent Parent frame, used if a diloge is displayed
     */
    public void editParameters( java.awt.Frame parent ) {
    }
    
    public boolean collisionEnabled() {
        return collisionEnabled;
    }
    
    public void setCollisionEnabled( boolean enable ) {
        collisionEnabled = enable;
    }
      
}
